/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * SchemeJException.java:
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.exns;


/**
 * SchemeJException encapsulates information needed for debugging.
 *
 * @author Cheoljoo Jeong
 */

public class SchemeJException extends Exception {
  // error classes
  public static final int SysError = 0;
  public static final int EvalError = 1;
  public int errorClass = EvalError;

  // for debugging purpose
  public int lineNo;
  public int columnNo;
  public int expr;
  //  public Environment env;
  
  /**
   * constructor
   */
  public SchemeJException() {}

  /**
   * constructor
   */
  public SchemeJException(String msg) {
    super(msg);

    lineNo = 0;
    columnNo = 0;
    //    env = null;
    errorClass = EvalError;
  }

  /**
   * constructor
   */
  public SchemeJException(int errorClass, String msg) {
    super(msg);
    lineNo = 0;
    columnNo = 0;
    //    env = null;
    this.errorClass = errorClass;
  }

  /**
   * Returns the error class.
   */
  public int getErrorClass() {
    return errorClass;
  }
}

