package kudos.ide.action.key;

import java.awt.datatransfer.*;
import java.awt.event.*;

import kudos.ide.form.*;
import kudos.ide.form.textarea.*;

public class Cut extends EditAction
{
	public void actionPerformed(ActionEvent evt)
	{
		MainView mainView = getMainView(evt);
		EditTextArea editTextArea = mainView.getEditTextArea();
		if(editTextArea.isEditable())
		{
			String selection = editTextArea.getSelectedText();
			if(selection == null)
				return;

			Clipboard clipboard = mainView.getToolkit().getSystemClipboard();

			int repeatCount = mainView.getInputHandler().getRepeatCount();
			StringBuffer buf = new StringBuffer();
			for(int i = 0; i < repeatCount; i++)
				buf.append(selection);

			clipboard.setContents(new StringSelection(buf.toString()),null);

			editTextArea.setSelectedText("");
		}
		else
			editTextArea.getToolkit().beep();
	}

	public boolean isRepeatable()
	{
		return false;
	}
}