package kudos.ide.action.key;

import java.awt.event.*;

import kudos.ide.form.*;
import kudos.ide.form.textarea.*;
import kudos.ide.tools.*;

public class End extends EditAction
{
	private boolean select;

	public End()
	{
		this(false);
	}

	public End(boolean select)
	{
		this.select = select;
	}

	public void actionPerformed(ActionEvent evt)
	{
		MainView mainView = getMainView(evt);
		EditTextArea editTextArea = mainView.getEditTextArea();
		InputHandler inputHandler = mainView.getInputHandler();

		int caret = editTextArea.getCaretPosition();
		int line = editTextArea.getCaretLine();

		int lastIndent = Util.getTrailingWhiteSpace(editTextArea
			.getLineText(line));

		int lastOfLine = editTextArea.getLineEndOffset(line) - 1;

		lastIndent = lastOfLine - lastIndent;
		if(lastIndent == editTextArea.getLineStartOffset(line))
			lastIndent = lastOfLine;

		int lastVisibleLine = editTextArea.getFirstLine() + editTextArea.getVisibleLines();

		if(lastVisibleLine >= editTextArea.getLineCount())
			lastVisibleLine = editTextArea.getLineCount() - 1;
		else if(lastVisibleLine <= editTextArea.getElectricScroll())
			lastVisibleLine = 0;
		else
			lastVisibleLine -= (editTextArea.getElectricScroll() + 1);

		int lastVisible = editTextArea.getLineEndOffset(lastVisibleLine) - 1;

		int[] positions = { lastIndent, lastOfLine, lastVisible };
		int count;
		if(inputHandler.getLastAction() == this)
		{
			count = Math.min(positions.length,inputHandler
				.getLastActionCount()) - 1;
		}
		else
			count = 0;

		caret = positions[count];

		if(select)
			editTextArea.select(editTextArea.getMarkPosition(),caret);
		else
			editTextArea.setCaretPosition(caret);
	}
}