package kudos.ide.action.key;

import java.awt.event.*;

import kudos.ide.form.*;
import kudos.ide.form.textarea.*;
import kudos.ide.tools.*;

public class Home extends EditAction
{
	private boolean select;

	public Home()
	{
		this(false);
	}

	public Home(boolean select)
	{
		this.select = select;
	}

	public void actionPerformed(ActionEvent evt)
	{
		MainView mainView = getMainView(evt);
		EditTextArea editTextArea = mainView.getEditTextArea();
		InputHandler inputHandler = mainView.getInputHandler();

		int caret = editTextArea.getCaretPosition();
		int line = editTextArea.getCaretLine();

		int firstIndent = Util.getLeadingWhiteSpace(editTextArea
			.getLineText(line));

		int firstOfLine = editTextArea.getLineStartOffset(line);

		firstIndent = firstOfLine + firstIndent;
		if(firstIndent == editTextArea.getLineEndOffset(line) - 1)
			firstIndent = firstOfLine;

		int firstLine = editTextArea.getFirstLine();
		int electricScroll = editTextArea.getElectricScroll();

		int firstVisibleLine = (firstLine <= electricScroll) ? 0 :
			firstLine + electricScroll;
		if(firstVisibleLine >= editTextArea.getLineCount())
			firstVisibleLine = editTextArea.getLineCount() - 1;

		int firstVisible = editTextArea.getLineStartOffset(firstVisibleLine);

		int[] positions = { firstIndent, firstOfLine, firstVisible };
		int count;
		if(inputHandler.getLastAction() == this)
		{
			count = Math.min(positions.length,inputHandler
				.getLastActionCount()) - 1;
		}
		else
			count = 0;

		caret = positions[count];

		if(select)
			editTextArea.select(editTextArea.getMarkPosition(),caret);
		else
			editTextArea.setCaretPosition(caret);
	}
}