package kudos.ide.action.key;

import java.awt.event.*;

import kudos.ide.form.*;
import kudos.ide.form.textarea.*;

public class LeftWord extends EditAction
{
	private boolean select;

	public LeftWord()
	{
		this(false);
	}

	public LeftWord(boolean select)
	{
		this.select = select;
	}

	public void actionPerformed(ActionEvent evt)
	{
		MainView mainView = getMainView(evt);
		EditTextArea editTextArea = mainView.getEditTextArea();
		int caret = editTextArea.getCaretPosition();
		int line = editTextArea.getCaretLine();
		int lineStart = editTextArea.getLineStartOffset(line);
		caret -= lineStart;

		String lineText = editTextArea.getLineText(editTextArea.getCaretLine());

		if(caret == 0)
		{
			if(lineStart == 0)
			{
				mainView.getToolkit().beep();
				return;
			}
			caret--;
		}
		else
		{
			caret = TextUtilities.findWordStart(lineText,caret - 1,null);
		}

		if(select)
			editTextArea.select(editTextArea.getMarkPosition(),
				lineStart + caret);
		else
			editTextArea.setCaretPosition(lineStart + caret);
	}
}