package kudos.ide.action.key;

import java.awt.event.*;

import kudos.ide.form.*;
import kudos.ide.form.textarea.*;
import kudos.ide.tools.*;

public class PageDown extends EditAction
{
	private boolean select;

	public PageDown()
	{
		this(false);
	}

	public PageDown(boolean select)
	{
		this.select = select;
	}

	public void actionPerformed(ActionEvent evt)
	{
		MainView mainView = getMainView(evt);
		EditTextArea editTextArea = mainView.getEditTextArea();
		int lineCount = editTextArea.getLineCount();
		int firstLine = editTextArea.getFirstLine();
		int visibleLines = editTextArea.getVisibleLines();
		int line = editTextArea.getCaretLine();

		firstLine += visibleLines;

		if(firstLine + visibleLines >= lineCount - 1)
			firstLine = lineCount - visibleLines;

		editTextArea.setFirstLine(firstLine);

		int caret = editTextArea.getLineStartOffset(
			Math.min(editTextArea.getLineCount() - 1,
			line + visibleLines));
		if(select)
			editTextArea.select(editTextArea.getMarkPosition(),caret);
		else
			editTextArea.setCaretPosition(caret);
	}
}