package kudos.ide.action.key;

import java.awt.event.*;

import kudos.ide.form.*;
import kudos.ide.form.textarea.*;
import kudos.ide.tools.*;

public class PageUp extends EditAction
{
	private boolean select;

	public PageUp()
	{
		this(false);
	}

	public PageUp(boolean select)
	{
		this.select = select;
	}

	public void actionPerformed(ActionEvent evt)
	{
		MainView mainView = getMainView(evt);
		EditTextArea editTextArea = mainView.getEditTextArea();
		int firstLine = editTextArea.getFirstLine();
		int visibleLines = editTextArea.getVisibleLines();
		int line = editTextArea.getCaretLine();

		if(firstLine < visibleLines)
			firstLine = visibleLines;

		editTextArea.setFirstLine(firstLine - visibleLines);

		int caret = editTextArea.getLineStartOffset(
			Math.max(0,line - visibleLines));
		if(select)
			editTextArea.select(editTextArea.getMarkPosition(),caret);
		else
			editTextArea.setCaretPosition(caret);
	}
}