package kudos.ide.action.key;

import java.awt.event.*;

import kudos.ide.form.*;
import kudos.ide.form.textarea.*;

public class Up extends EditAction
{
	private boolean select;

	public Up()
	{
		this(false);
	}

	public Up(boolean select)
	{
		this.select = select;
	}

	public void actionPerformed(ActionEvent evt)
	{
		MainView mainView = getMainView(evt);
		EditTextArea editTextArea = mainView.getEditTextArea();
		int caret = editTextArea.getCaretPosition();
		int line = editTextArea.getCaretLine();

		if(line == 0)
		{
			mainView.getToolkit().beep();
			return;
		}

		int magic = editTextArea.getMagicCaretPosition();
		if(magic == -1)
		{
			magic = editTextArea.offsetToX(line,
				caret - editTextArea.getLineStartOffset(line));
		}

		caret = editTextArea.getLineStartOffset(line - 1)
			+ editTextArea.xToOffset(line - 1,magic + 1);

		if(select)
			editTextArea.select(editTextArea.getMarkPosition(),caret);
		else
			editTextArea.setCaretPosition(caret);
		editTextArea.setMagicCaretPosition(magic);
	}
}