package kudos.ide.form;

import javax.swing.*;

public class EditPopupMenu extends JPopupMenu
{
  private MainControl mainControl;

  public EditPopupMenu(MainControl mainControl)
  {
    this.mainControl = mainControl;

    addMenuItem();
  }

  public void addMenuItem()
  {
    JMenuItem menuItemAction = new JMenuItem(mainControl.undoAction);
    menuItemAction.setText(mainControl.undoAction.TOOLTIP_TEXT);
    menuItemAction.setMnemonic(mainControl.undoAction.MNEMONIC);
    menuItemAction.setAccelerator(KeyStroke.getKeyStroke(mainControl.undoAction.SHORT_KEY,
							 mainControl.undoAction.SHORT_KEY_MASK));
    add(menuItemAction);

    menuItemAction = new JMenuItem(mainControl.redoAction);
    menuItemAction.setText(mainControl.redoAction.TOOLTIP_TEXT);
    menuItemAction.setMnemonic(mainControl.redoAction.MNEMONIC);
    menuItemAction.setAccelerator(KeyStroke.getKeyStroke(mainControl.redoAction.SHORT_KEY,
							 mainControl.redoAction.SHORT_KEY_MASK));
    add(menuItemAction);

    addSeparator();

    menuItemAction = new JMenuItem(mainControl.copyAction);
    menuItemAction.setText(mainControl.copyAction.TOOLTIP_TEXT);
    menuItemAction.setMnemonic(mainControl.copyAction.MNEMONIC);
    menuItemAction.setAccelerator(KeyStroke.getKeyStroke(mainControl.copyAction.SHORT_KEY,
							 mainControl.copyAction.SHORT_KEY_MASK));
    add(menuItemAction);

    menuItemAction = new JMenuItem(mainControl.cutAction);
    menuItemAction.setText(mainControl.cutAction.TOOLTIP_TEXT);
    menuItemAction.setMnemonic(mainControl.cutAction.MNEMONIC);
    menuItemAction.setAccelerator(KeyStroke.getKeyStroke(mainControl.cutAction.SHORT_KEY,
							 mainControl.cutAction.SHORT_KEY_MASK));
    add(menuItemAction);

    menuItemAction = new JMenuItem(mainControl.pasteAction);
    menuItemAction.setText(mainControl.pasteAction.TOOLTIP_TEXT);
    menuItemAction.setMnemonic(mainControl.pasteAction.MNEMONIC);
    menuItemAction.setAccelerator(KeyStroke.getKeyStroke(mainControl.pasteAction.SHORT_KEY,
							 mainControl.pasteAction.SHORT_KEY_MASK));
    add(menuItemAction);

    addSeparator();

    menuItemAction = new JMenuItem(mainControl.selectAllAction);
    menuItemAction.setText(mainControl.selectAllAction.TOOLTIP_TEXT);
    menuItemAction.setMnemonic(mainControl.selectAllAction.MNEMONIC);
    menuItemAction.setAccelerator(KeyStroke.getKeyStroke(mainControl.selectAllAction.SHORT_KEY,
							 mainControl.selectAllAction.SHORT_KEY_MASK));
    add(menuItemAction);
  }
}
