package kudos.ide.form;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;

import kudos.ide.form.*;
import kudos.ide.form.textarea.*;
import kudos.ide.listener.Listener;
import kudos.ide.tools.Tools;

public class InterpreterView extends JTextArea {
  private static MainView mainView = null;
  private static Listener listener = null;
  private int textLength;

  public InterpreterView(MainView mainView) {
    this.mainView = mainView;
    setFont(new Font("Monospaced",Font.PLAIN,12));
    setTabSize(3);
    addComponentListener(new InterpreterHandler());
    addMouseListener(new MouseHandler());
    addMouseMotionListener(new DragHandler());
    addKeyListener(new KeyHandler());
    listener = new Listener(mainView);
  }

  public void repl() {
    Listener listener = getListener();
    listener.repl();
  }

  public void setInterpreterSize() {
    mainView.setOldInterpreterSplitPaneSize();
  }

  public void setTextInput(String text) {
    int len = getText().length();
    append(text);

    JScrollBar scrollBar = 
      mainView.getInterpreterScrollPane().getVerticalScrollBar();
    scrollBar.setValue(scrollBar.getMaximum());
    mainView.getInterpreterScrollPane().setVerticalScrollBar(scrollBar);

    textLength = getText().length();
  }

  public static Listener getListener() {
    if (listener == null) {
      listener = new Listener(mainView);
    }
    return listener;
  }

  private void setCaret() {
    getCaret().setDot(getText().length());
  }

  private void characterArray() {
    try {
      String text = getText(textLength, getText().length() - textLength - 1);
      if(listener != null) {
	listener.readCharecter(text);
      }
    } catch(BadLocationException e) {
    }
  }

  private void setKeyType(KeyEvent evt)
  {
    try	 {
      if(evt.getKeyCode() == KeyEvent.VK_ENTER) {
	setEditable(false);
      }

      if(getCaretPosition() - getLineStartOffset(getLineCount()-1) <= 3 
	 && evt.getKeyCode() == KeyEvent.VK_BACK_SPACE) {
	append(" ");
	return;
      }
    } catch(BadLocationException e) {
    }
  }

  private void setKeyControl(KeyEvent evt)
  {
    if(evt.getKeyCode() == KeyEvent.VK_ENTER)
    {
      setEditable(true);
      insert("\n", getText().length());
      characterArray();
      repl();
      return;
    }
  }

  private class InterpreterHandler extends ComponentAdapter {
    public void componentResized(ComponentEvent e) {
      setInterpreterSize();
    }
  }

  private class MouseHandler extends MouseAdapter {
    public void mousePressed(MouseEvent evt) {
      setCaret();
    }

    public void mouseReleased(MouseEvent evt) {
      setCaret();
    }
  }

  private class DragHandler extends MouseMotionAdapter {
    public void mouseDragged(MouseEvent evt) {
    }
  }

  private class KeyHandler extends KeyAdapter {
    public void keyPressed(KeyEvent evt) {
      setKeyType(evt);
      setCaret();
    }

    public void keyReleased(KeyEvent evt) {
      setKeyControl(evt);
      setCaret();
    }
  }	
}
