package kudos.ide.form;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import java.lang.reflect.*;

import kudos.ide.form.*;
import kudos.jvm.*;

public class JVMBrowserView extends JTabbedPane implements KudosTreeObserver {
  // making this class singleton 
  // cjeong
  private static JVMBrowserView instance = null;

  private JScrollPane systemClassTab = null;
  private JScrollPane userDefineClassTab = null;
  private JScrollPane componentTab = null;
  private JScrollPane connectorTab = null;

  private TreeModel systemClassTreeModel = null;
  private TreeModel userDefineClassTreeModel = null;

  private KudosClassLoader kudosClassLoader = null;
  private MainView mainView = null;
  public JTree stree = null;
  public JTree utree = null;

  public JVMBrowserView(MainView mainView)
  {
    this.mainView = mainView;
    addComponentListener(new JVMBrowserHandler());
    initData();
    initTab();
  }

  public static JVMBrowserView getInstance(MainView mainView) {
    if (instance == null) {
      instance = new JVMBrowserView(mainView);
    }
    return instance;
  }

  public static JVMBrowserView getInstance() {
    return instance;
  }

  private void initData()
  {
    kudosClassLoader = KudosClassLoader.getInstance(this);
  }

  private void initTab()
  {
    systemClassTab = new JScrollPane();
    systemClassTab.setName("System Class");
    userDefineClassTab = new JScrollPane();
    userDefineClassTab.setName("User Derined Class");
    JPanel panel1 = new JPanel();
    JPanel panel2 = new JPanel();
    panel1.setBackground(Color.white);
    panel2.setBackground(Color.white);
    componentTab = new JScrollPane();
    componentTab.setName("Component");
    connectorTab = new JScrollPane();
    connectorTab.setName("Connector");

    componentTab.getViewport().add(panel1);
    connectorTab.getViewport().add(panel2);
    addTab(systemClassTab.getName(), systemClassTab);
    addTab(userDefineClassTab.getName(), userDefineClassTab);
    addTab(componentTab.getName(), componentTab);
    addTab(connectorTab.getName(), connectorTab);

    systemClassChanged();
    userDefineClassChanged();
  }

  private void systemClass(TreeModel systemClassTreeModel)
  {
    if(systemClassTreeModel != null)
    {
      stree = new JTree(systemClassTreeModel);

      // added by cjeong
      TreeSelectionListener listener = new TreeSelectionListener() {
	  public void valueChanged(TreeSelectionEvent e) {
	    DefaultMutableTreeNode node = 
	      (DefaultMutableTreeNode) stree.getLastSelectedPathComponent();
	    if (node == null) { 
	      return;
	    }
	    Object nodeinfo = node.getUserObject();
	    if (nodeinfo != null) {
	      Class theClass = (Class) nodeinfo;
	      String text = ClassInfo.getInfo(theClass);
	      mainView.jvmHelpTextBox.setText(text);
	    }
	  }
	};
      stree.addTreeSelectionListener(listener);
      systemClassTab.getViewport().add(stree);
    }
  }

  private void userDefineClass(TreeModel userDefineClassTreeModel)
  {
    if(userDefineClassTreeModel != null)
    {
      utree = new JTree(userDefineClassTreeModel);

      // added by cjeong
      TreeSelectionListener listener = new TreeSelectionListener() {
	  public void valueChanged(TreeSelectionEvent e) {
	    DefaultMutableTreeNode node = 
	      (DefaultMutableTreeNode) utree.getLastSelectedPathComponent();
	    if (node == null) { 
	      return;
	    }
	    Object nodeinfo = node.getUserObject();
	    if (nodeinfo != null) {
	      Class theClass = (Class) nodeinfo;
	      String text = ClassInfo.getInfo(theClass);
	      mainView.jvmHelpTextBox.setText(text);
	    }
	  }
	};
      utree.addTreeSelectionListener(listener);
      userDefineClassTab.getViewport().add(utree);
    }
  }

  public void systemClassChanged()
  {
    this.systemClassTreeModel = 
      kudosClassLoader.getLoadedSystemClassHierarchy();
    systemClass(systemClassTreeModel);
  }

  public void userDefineClassChanged()
  {
    this.userDefineClassTreeModel = 
      kudosClassLoader.getLoadedUserClassHierarchy();
    userDefineClass(userDefineClassTreeModel);
  }

  public void setJVMBrowserSize()
  {
    mainView.setInterpreterSplitPaneDividerLocation();
  }

  public class JVMBrowserHandler extends ComponentAdapter
  {
    public void componentResized(ComponentEvent e)
    {
      setJVMBrowserSize();
    }
  }
}

