//2000-06-10
package kudos.ide.form;

import javax.swing.*;

import kudos.ide.action.menu.*;

public class MainMenuBar extends JMenuBar
{
    private MainControl mainControl;
    private KUDOSActions kudosActions[];

    private JCheckBoxMenuItem menuItemJVMBrowser = null;
    private JCheckBoxMenuItem menuItemInterpreter = null;

    public MainMenuBar(MainControl mainControl)
    {
	this.mainControl = mainControl;
	kudosActions = mainControl.getKudosActions();
	makeFileMenu();
	makeEditMenu();
	makeViewMenu();
	makeSchemeJMenu();
	makeHelpMenu();
    }
    public boolean getStateJVMBrowser()
    {
	return menuItemJVMBrowser.getState();
    }
    public void setStateJVMBrowser(boolean state)
    {
	menuItemJVMBrowser.setState(state);
    }
    public boolean getStateInterpreter()
    {
	return menuItemInterpreter.getState();
    }
    public void setStateInterpreter(boolean state)
    {
	menuItemInterpreter.setState(state);
    }

    private void makeFileMenu()
    {
	JMenu menuFile = new JMenu("File");
	menuFile.setMnemonic('f');

	for (int i=0; i<kudosActions.length; i++)
	{
	    String command = kudosActions[i].getCommand();

	    if(command.equalsIgnoreCase("NEW_FILE"))
	    {
		JMenuItem menuItemNewFile = new JMenuItem(kudosActions[i]);
		menuItemNewFile.setText(kudosActions[i].TOOLTIP_TEXT);
		menuItemNewFile.setMnemonic(kudosActions[i].MNEMONIC);
		menuItemNewFile.setAccelerator(KeyStroke.getKeyStroke(kudosActions[i].SHORT_KEY, kudosActions[i].SHORT_KEY_MASK));
		menuFile.add(menuItemNewFile);
	    }
	    else if(command.equalsIgnoreCase("OPEN_FILE"))
	    {
		JMenuItem menuItemOpenFile = new JMenuItem(kudosActions[i]);
		menuItemOpenFile.setText(kudosActions[i].TOOLTIP_TEXT);
		menuItemOpenFile.setMnemonic(kudosActions[i].MNEMONIC);
		menuItemOpenFile.setAccelerator(KeyStroke.getKeyStroke(kudosActions[i].SHORT_KEY, kudosActions[i].SHORT_KEY_MASK));
		menuFile.add(menuItemOpenFile);
	    }
	    else if(command.equalsIgnoreCase("INSERT_FILE"))
	    {
		JMenuItem menuItemInsertFile = new JMenuItem(kudosActions[i]);
		menuItemInsertFile.setText(kudosActions[i].TOOLTIP_TEXT);
		menuItemInsertFile.setMnemonic(kudosActions[i].MNEMONIC);
		menuFile.add(menuItemInsertFile);
		menuFile.addSeparator();
	    }
	    else if(command.equalsIgnoreCase("SAVE"))
	    {
		JMenuItem menuItemSave = new JMenuItem(kudosActions[i]);
		menuItemSave.setText(kudosActions[i].TOOLTIP_TEXT);
		menuItemSave.setMnemonic(kudosActions[i].MNEMONIC);
		menuItemSave.setAccelerator(KeyStroke.getKeyStroke(kudosActions[i].SHORT_KEY, kudosActions[i].SHORT_KEY_MASK));
		menuFile.add(menuItemSave);
	    }
	    else if(command.equalsIgnoreCase("SAVE_AS"))
	    {
		JMenuItem menuItemSaveAs = new JMenuItem(kudosActions[i]);
		menuItemSaveAs.setText(kudosActions[i].TOOLTIP_TEXT);
		menuItemSaveAs.setMnemonic(kudosActions[i].MNEMONIC);
		menuFile.add(menuItemSaveAs);
		menuFile.addSeparator();
	    }
	    else if(command.equalsIgnoreCase("EXIT"))
	    {
		JMenuItem menuItemExit = new JMenuItem(kudosActions[i]);
		menuItemExit.setText(kudosActions[i].TOOLTIP_TEXT);
		menuItemExit.setMnemonic(kudosActions[i].MNEMONIC);
		menuItemExit.setAccelerator(KeyStroke.getKeyStroke(kudosActions[i].SHORT_KEY, kudosActions[i].SHORT_KEY_MASK));
		menuFile.add(menuItemExit);
	    }
	}
	add(menuFile);
    }

    private void makeEditMenu()
    {
	JMenu menuEdit = new JMenu("Edit");
	menuEdit.setMnemonic('e');

	for (int i=0; i<kudosActions.length; i++)
	{
	    String command = kudosActions[i].getCommand();

	    if(command.equalsIgnoreCase("UNDO"))
	    {
		JMenuItem menuItemUndo = new JMenuItem(kudosActions[i]);
		menuItemUndo.setText(kudosActions[i].TOOLTIP_TEXT);
		menuItemUndo.setMnemonic(kudosActions[i].MNEMONIC);
		menuItemUndo.setAccelerator(KeyStroke.getKeyStroke(kudosActions[i].SHORT_KEY, kudosActions[i].SHORT_KEY_MASK));
		menuEdit.add(menuItemUndo);
	    }
	    else if(command.equalsIgnoreCase("REDO"))
	    {
		JMenuItem menuItemRedo = new JMenuItem(kudosActions[i]);
		menuItemRedo.setText(kudosActions[i].TOOLTIP_TEXT);
		menuItemRedo.setMnemonic(kudosActions[i].MNEMONIC);
		menuItemRedo.setAccelerator(KeyStroke.getKeyStroke(kudosActions[i].SHORT_KEY, kudosActions[i].SHORT_KEY_MASK));
		menuEdit.add(menuItemRedo);
		menuEdit.addSeparator();
	    }
	    else if(command.equalsIgnoreCase("COPY"))
	    {
		JMenuItem menuItemCopy = new JMenuItem(kudosActions[i]);
		menuItemCopy.setText(kudosActions[i].TOOLTIP_TEXT);
		menuItemCopy.setMnemonic(kudosActions[i].MNEMONIC);
		menuItemCopy.setAccelerator(KeyStroke.getKeyStroke(kudosActions[i].SHORT_KEY, kudosActions[i].SHORT_KEY_MASK));
		menuEdit.add(menuItemCopy);
	    }
	    else if(command.equalsIgnoreCase("CUT"))
	    {
		JMenuItem menuItemCut = new JMenuItem(kudosActions[i]);
		menuItemCut.setText(kudosActions[i].TOOLTIP_TEXT);
		menuItemCut.setMnemonic(kudosActions[i].MNEMONIC);
		menuItemCut.setAccelerator(KeyStroke.getKeyStroke(kudosActions[i].SHORT_KEY, kudosActions[i].SHORT_KEY_MASK));
		menuEdit.add(menuItemCut);
	    }
	    else if(command.equalsIgnoreCase("PASTE"))
	    {
		JMenuItem menuItemPaste = new JMenuItem(kudosActions[i]);
		menuItemPaste.setText(kudosActions[i].TOOLTIP_TEXT);
		menuItemPaste.setMnemonic(kudosActions[i].MNEMONIC);
		menuItemPaste.setAccelerator(KeyStroke.getKeyStroke(kudosActions[i].SHORT_KEY, kudosActions[i].SHORT_KEY_MASK));
		menuEdit.add(menuItemPaste);
		menuEdit.addSeparator();
	    }
	    else if(command.equalsIgnoreCase("SELECT_ALL"))
	    {
		JMenuItem menuItemSelectAll = new JMenuItem(kudosActions[i]);
		menuItemSelectAll.setText(kudosActions[i].TOOLTIP_TEXT);
		menuItemSelectAll.setMnemonic(kudosActions[i].MNEMONIC);
		menuItemSelectAll.setAccelerator(KeyStroke.getKeyStroke(kudosActions[i].SHORT_KEY, kudosActions[i].SHORT_KEY_MASK));
		menuEdit.add(menuItemSelectAll);
	    }
	    else if(command.equalsIgnoreCase("CLEAR"))
	    {
		JMenuItem menuItemClear = new JMenuItem(kudosActions[i]);
		menuItemClear.setText(kudosActions[i].TOOLTIP_TEXT);
		menuItemClear.setMnemonic(kudosActions[i].MNEMONIC);
		menuEdit.add(menuItemClear);
	    }
	}
	add(menuEdit);

    }

    private  void makeViewMenu()
    {
	JMenu menuView = null;

	menuView = new JMenu("View");
	menuView.setMnemonic('v');

	for (int i=0; i<kudosActions.length; i++)
	{
	    String command = kudosActions[i].getCommand();

	    if(command.equalsIgnoreCase("JVM_BROWSER"))
	    {
		menuItemJVMBrowser = new JCheckBoxMenuItem(kudosActions[i]);
		menuItemJVMBrowser.setText(kudosActions[i].TOOLTIP_TEXT);
		menuItemJVMBrowser.setMnemonic(kudosActions[i].MNEMONIC);
		menuItemJVMBrowser.setAccelerator(KeyStroke.getKeyStroke(kudosActions[i].SHORT_KEY, kudosActions[i].SHORT_KEY_MASK));
		menuItemJVMBrowser.setSelected(true);
		menuView.add(menuItemJVMBrowser);
	    }
	    else if(command.equalsIgnoreCase("INTERPRETER"))
	    {
		menuItemInterpreter = new JCheckBoxMenuItem(kudosActions[i]);
		menuItemInterpreter.setText(kudosActions[i].TOOLTIP_TEXT);
		menuItemInterpreter.setMnemonic(kudosActions[i].MNEMONIC);
		menuItemInterpreter.setAccelerator(KeyStroke.getKeyStroke(kudosActions[i].SHORT_KEY, kudosActions[i].SHORT_KEY_MASK));
		menuItemInterpreter.setSelected(true);
		menuView.add(menuItemInterpreter);
	    }
	}
	add(menuView);
    }

    private void makeSchemeJMenu()
    {
	JMenu menuSchemeJ = new JMenu("SchemeJ");
	menuSchemeJ.setMnemonic('S');

	for (int i=0; i<kudosActions.length; i++)
	{
	    String command = kudosActions[i].getCommand();

	    if(command.equalsIgnoreCase("EVALUATE_BUFFER"))
	    {
		JMenuItem menuItemEvaluateBuffer = new JMenuItem(kudosActions[i]);
		menuItemEvaluateBuffer.setText(kudosActions[i].TOOLTIP_TEXT);
		menuItemEvaluateBuffer.setMnemonic(kudosActions[i].MNEMONIC);
		menuItemEvaluateBuffer.setAccelerator(KeyStroke.getKeyStroke(kudosActions[i].SHORT_KEY, kudosActions[i].SHORT_KEY_MASK));
		menuSchemeJ.add(menuItemEvaluateBuffer);
	    }
	    else if(command.equalsIgnoreCase("EVALUATE_DEFINITION"))
	    {
		JMenuItem menuItemEvaluateDefinition = new JMenuItem(kudosActions[i]);
		menuItemEvaluateDefinition.setText(kudosActions[i].TOOLTIP_TEXT);
		menuItemEvaluateDefinition.setMnemonic(kudosActions[i].MNEMONIC);
		menuItemEvaluateDefinition.setAccelerator(KeyStroke.getKeyStroke(kudosActions[i].SHORT_KEY, kudosActions[i].SHORT_KEY_MASK));
		menuSchemeJ.add(menuItemEvaluateDefinition);
	    }
	    else if(command.equalsIgnoreCase("EVALUATE_EXPRESSION"))
	    {
		JMenuItem menuItemEvaluateExpression = new JMenuItem(kudosActions[i]);
		menuItemEvaluateExpression.setText(kudosActions[i].TOOLTIP_TEXT);
		menuItemEvaluateExpression.setMnemonic(kudosActions[i].MNEMONIC);
		menuItemEvaluateExpression.setAccelerator(KeyStroke.getKeyStroke(kudosActions[i].SHORT_KEY, kudosActions[i].SHORT_KEY_MASK));
		menuSchemeJ.add(menuItemEvaluateExpression);
		menuSchemeJ.addSeparator();
	    }
	    else if(command.equalsIgnoreCase("COMPILE"))
	    {
		JMenuItem menuItemCompile = new JMenuItem(kudosActions[i]);
		menuItemCompile.setText(kudosActions[i].TOOLTIP_TEXT);
		menuItemCompile.setMnemonic(kudosActions[i].MNEMONIC);
		menuItemCompile.setAccelerator(KeyStroke.getKeyStroke(kudosActions[i].SHORT_KEY, kudosActions[i].SHORT_KEY_MASK));
		menuSchemeJ.add(menuItemCompile);
	    }
	}
	add(menuSchemeJ);
    }

    private void makeHelpMenu()
    {
	JMenu menuHelp = new JMenu("Help");
	menuHelp.setMnemonic('h');

	for (int i=0; i<kudosActions.length; i++)
	{
	    String command = kudosActions[i].getCommand();

	    if(command.equalsIgnoreCase("ABOUT"))
	    {
		JMenuItem menuItemAbout = new JMenuItem(kudosActions[i]);
		menuItemAbout.setText(kudosActions[i].TOOLTIP_TEXT);
		menuItemAbout.setMnemonic(kudosActions[i].MNEMONIC);
		menuHelp.add(menuItemAbout);
	    }
	}
	add(menuHelp);
    }
}
