package kudos.ide.form;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;

import kudos.ide.tools.Tools;
import kudos.ide.image.ImageLoader;

public class SplashWindow extends Window
{
	private JLabel statusLabel = null;

	public SplashWindow(Frame frame)
	{
		super(frame);

		setLayout(null);

		int ma = 2;
		int winWidth = Tools.splashWidth();
		int winHeigth = Tools.splashHeigth();
		Icon splashIcon = ImageLoader.getIcon(ImageLoader.controlIconPaths[ImageLoader.SPLASH]);
		Dimension dimension = Toolkit.getDefaultToolkit().getScreenSize();
		JPanel panel = new JPanel();
		JLabel label = new JLabel(splashIcon);
		statusLabel = new JLabel("KUDOS Program Loading..." , 4);

		panel.setLayout(null);
		panel.setBackground(Color.white);

		statusLabel.setFont(new Font("Dialog", 0, 9));
		statusLabel.setForeground(Color.black);

		setSize(winWidth, winHeigth);
		Rectangle rect = getBounds();
		setBackground(Color.black);
		setLocation((dimension.width - rect.width) / 2, (dimension.height - rect.height) / 2);
		setVisible(true);

		panel.add(statusLabel);
		panel.add(label);
		add(panel);

		panel.setBounds(ma, ma, winWidth - ma * 2, winHeigth - ma * 2);
		label.setBounds(ma, ma, winWidth - ma * 2, winHeigth - ma * 2 - 14);
		statusLabel.setBounds(ma, winHeigth - 20, winWidth - ma * 2, 20);
	}

	public void setStatus(String s)
	{
		statusLabel.setText(s);
	}
}