//2000-05-22
package kudos.ide.form;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;

class StatusBar extends JPanel implements ComponentListener
{
  private static final int height = 20;
  private static final int statusWidth = 100;
  private int width;

  private JLabel mainStatus;
  private JLabel status1;
  private JLabel status2;
  private JLabel status3;

  public StatusBar(int width)
  {
    this.width = width;
    setSize(width, height);
    addComponentListener(this);
    setLayout(null);
    initControls();
  }
  private void initControls()
  {
    int gab = 5;
    int x3 = width - (statusWidth);
    int x2 = width - (statusWidth*2 + gab);
    int x1 = width - (statusWidth*3 + gab*2);

    mainStatus = new JLabel("Ready ...", JLabel.LEFT);
    add(mainStatus);
    mainStatus.setSize(width - statusWidth*3 - gab*4, height);
    mainStatus.setLocation(0, gab);

    status1 = new JLabel("", JLabel.CENTER);
    status1.setBorder(new SoftBevelBorder(BevelBorder.LOWERED));
    add(status1);
    status1.setSize(statusWidth, height);
    status1.setLocation(x1, gab);

    status2 = new JLabel("", JLabel.CENTER);
    status2.setBorder(new SoftBevelBorder(BevelBorder.LOWERED));
    status2.setSize(statusWidth, height);
    status2.setLocation(x2, gab);
    add(status2);

    status3 = new JLabel("", JLabel.CENTER);
    status3.setBorder(new SoftBevelBorder(BevelBorder.LOWERED));
    add(status3);
    status3.setSize(statusWidth, height);
    status3.setLocation(x3, gab);
  }
  private void resizeStatusBar()
  {
    int gab = 5;
    int x3 = width - (statusWidth);
    int x2 = width - (statusWidth*2 + gab);
    int x1 = width - (statusWidth*3 + gab*2);

    mainStatus.setSize(width - statusWidth*3 - gab*4, height);
    mainStatus.setLocation(0, gab);

    status1.setLocation(x1, gab);
    status2.setLocation(x2, gab);
    status3.setLocation(x3, gab);
  }
  public void paint(Graphics g)
  {
    super.paint(g);
    Color light = getBackground().brighter().brighter().brighter();
    Color dark = getBackground().darker().darker().darker();

    g.setColor(light);
    g.drawLine(1,2,width,2);
    g.setColor(dark);
    g.drawLine(0,1,width-1,1);
  }
  /*	public Insets getInsets()
	{
	return new Insets();
	}*/
  public Dimension getPreferredSize()
  {
    return new Dimension(width, height+5);
  }
  public void componentResized(ComponentEvent e)
  {
    this.width = getWidth();
    resizeStatusBar();
  }
  public void componentMoved(ComponentEvent e){}
  public void componentShown(ComponentEvent e){}
  public void componentHidden(ComponentEvent e){}
}
