package kudos.ide.form.textarea;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;

import kudos.ide.form.*;

public abstract class EditAction implements ActionListener
{
  private String name = null;

  public EditAction()
  {
  }

  public EditAction(String name)
  {
    this.name = name;
  }

  public final String getName()
  {
    if(name == null)
    {
      String clazz = getClass().getName();
      clazz = clazz.substring("kudos.ide.action.key.".length());
      name = clazz;
    }

    return name;
  }

  public static MainView getMainView(EventObject evt)
  {
    if(evt != null)
    {
      Object o = evt.getSource();
      if(o instanceof Component)
	return getMainView((Component)o);
    }
    return null;
  }

  public static MainView getMainView(Component comp)
  {
    for(;;)
    {
      if(comp instanceof MainView)
	return (MainView)comp;
      else if(comp instanceof JPopupMenu)
	comp = ((JPopupMenu)comp).getInvoker();
      else if(comp != null)
	comp = comp.getParent();
      else
	break;
    }
    return null;
  }

  public boolean isWrapper()
  {
    return false;
  }

  public boolean isRepeatable()
  {
    return true;
  }

  public static class Wrapper extends EditAction
  {
    private EditAction action;

    public Wrapper(String name)
    {
      super(name);
    }

    public Wrapper(EditAction action)
    {
      super(action.name);
      this.action = action;
    }

    public boolean isWrapper()
    {
      return true;
    }

    public void actionPerformed(ActionEvent evt)
    {
      loadIfNecessary();
			
      MainView mainView = EditAction.getMainView(evt);
      mainView.getInputHandler().executeAction(action,
					       mainView.getEditTextArea(),evt.getActionCommand());
    }

    public void loadIfNecessary()
    {
      if(action != null)
	return;

      String className = "kudos.ide.action.key." + Wrapper.this.getName();

      try
      {
	Class clazz;
	ClassLoader loader = getClass().getClassLoader();
	if(loader == null)
	  clazz = Class.forName(className);
	else
	  clazz = loader.loadClass(className);

	action = (EditAction)clazz.newInstance();
      }
      catch(Exception e)
      {
      }
    }
  }
}
