package kudos.ide.form.textarea;

import java.awt.event.*;

import kudos.ide.form.*;

public abstract class InputHandler extends KeyAdapter
{
  protected boolean repeat;
  protected int repeatCount;
  protected int lastActionCount;

  protected MainView mainView = null;
  protected EditAction inputAction = null;
  protected EditAction lastAction = null;

  public InputHandler(MainView mainView)
  {
    this.mainView = mainView;
  }

  public EditAction getInputAction()
  {
    return inputAction;
  }

  public abstract void addKeyBinding(String keyBinding, EditAction action);

  public void setInputAction(EditAction inputAction)
  {
    this.inputAction = inputAction;
  }

  public EditAction getLastAction()
  {
    return lastAction;
  }

  public int getLastActionCount()
  {
    return lastActionCount;
  }

  public int getRepeatCount()
  {
    return (repeat ? Math.max(1,repeatCount) : 1);
  }

  public void executeAction(EditAction action, Object source,	String actionCommand)
  {
    ActionEvent evt = new ActionEvent(source, ActionEvent.ACTION_PERFORMED,
				      actionCommand);

    if(action.isWrapper())
    {
      action.actionPerformed(evt);
      return;
    }

    int _repeatCount = getRepeatCount();

    if(action.isRepeatable())
    {
      for(int i = 0; i < _repeatCount; i++)
	action.actionPerformed(evt);
    }
    else
      action.actionPerformed(evt);
  }
}
