package kudos.ide.form.textarea;

import java.awt.*;
import java.awt.datatransfer.*;
import java.util.*;

public class Registers
{
  private static Register[] registers;

  public static Register getRegister(char name)
  {
    return registers[name];
  }

  public static void setRegister(char name, Register newRegister)
  {
    registers = new Register[name + 1];
    registers[name] = newRegister;
  }

  public interface Register
  {
    String toString();

    void dispose();
  }

  public static class ClipboardRegister implements Register
  {
    public String toString()
    {
      Clipboard clipboard = Toolkit.getDefaultToolkit()
	.getSystemClipboard();
      try
      {
	String selection = (String)(clipboard
				    .getContents(this).getTransferData(
				      DataFlavor.stringFlavor));

	return selection.replace('\r','\n');
      }
      catch(Exception e)
      {
	return null;
      }
    }

    public void dispose() {}
  }

  private Registers() {}

  static
  {
    setRegister('$',new ClipboardRegister());
  }
}
