package kudos.ide.image;

import java.awt.*;
import java.net.*;
import javax.swing.*;

public class ImageLoader
{
  public static int NULL = 0;
  public static int NEW_FILE = 1;
  public static int OPEN_FILE = 2;
  public static int SAVE = 3;
  public static int PRINT_PREVIEW = 4;
  public static int PRINT = 5;
  public static int UNDO = 6;
  public static int REDO = 7;
  public static int COPY = 8;
  public static int CUT = 9;
  public static int PASTE = 10;
  public static int JVM_BROWSER = 11;
  public static int INTERPRETER = 12;
  public static int EVALUATE_BUFFER = 13;
  public static int EVALUATE_DEFINITION = 14;
  public static int EVALUATE_EXPRESSION = 15;
  public static int COMPILE = 16;
  public static int ABOUT = 17;
  public static int EXIT = 18;

  public static int SPLASH = 19;

  public static String controlIconPaths[] =
  {
    "toolbar/null.gif",
    "toolbar/newfile.gif",
    "toolbar/openfile.gif",
    "toolbar/save.gif",
    "toolbar/preview.gif",
    "toolbar/print.gif",
    "toolbar/undo.gif",
    "toolbar/redo.gif",
    "toolbar/copy.gif",
    "toolbar/cut.gif",
    "toolbar/paste.gif",
    "toolbar/jvmbrowser.gif",
    "toolbar/interpreter.gif",
    "toolbar/buffer.gif",
    "toolbar/definition.gif",
    "toolbar/expression.gif",
    "toolbar/compile.gif",
    "toolbar/about.gif",
    "toolbar/exit.gif",

    "splash/splash.gif"
  };
  public static Icon getIcon(String s) {
    ImageIcon imageicon = null;
        
    try {
      URL url = ImageLoader.class.getResource(s);
      imageicon = new ImageIcon(url);
    } catch(Exception _ex) {
      System.err.println("Problem loading icon: " + s);
    }
        
    return imageicon;
  }

  public static Image getImage(String s) {
    Image image = null;
        
    try  {
      URL url = ImageLoader.class.getResource(s);
      image = Toolkit.getDefaultToolkit().getImage(url);
    } catch(Exception _ex) {
      System.err.println("Problem loading image: " + s);
    }
        
    return image;
  }
}
