package kudos.ide.io;

import java.io.*;

import kudos.ide.form.*;
import kudos.ide.buffer.*;

public abstract class VirtualFileSystem
{
  public boolean load(MainView mainView, Buffer buffer, String path)
  {
    VirtualFileSystemManager.addIORequest(IORequest.LOAD,mainView,buffer,path,this);
    return true;
  }

  public boolean save(MainView mainView, Buffer buffer, String path)
  {
    VirtualFileSystemManager.addIORequest(IORequest.SAVE,mainView,buffer,path,this);
    return true;
  }

  public abstract Buffer showOpenDialog(MainView mainView, Buffer buffer);

  public abstract String showSaveDialog(MainView mainView, Buffer buffer);

  public abstract InputStream _createInputStream(MainView mainView, Buffer buffer,
						 String path, boolean ignoreErrors) throws IOException;

  public abstract OutputStream _createOutputStream(MainView mainView, Buffer buffer,
						   String path) throws IOException;
}
