package kudos.ide.io;

import kudos.ide.buffer.*;
import kudos.ide.form.*;

public class VirtualFileSystemManager
{
  private static VirtualFileSystem editFileDialog = new EditFileDialog();
  private static WorkThread ioThread = new WorkThread("KUDOS I/O daemon");

  public static void start()
  {
    ioThread.start();
  }

  public static VirtualFileSystem getEditFileDialog()
  {
    return editFileDialog;
  }

  public static void addIORequest(int type, MainView mainView, Buffer buffer,
				  String path, VirtualFileSystem vfs)
  {
    ioThread.addWorkRequest(new IORequest(type,mainView,buffer,path,vfs),false);
  }

  public static void runInAWTThread(Runnable run)
  {
    ioThread.addWorkRequest(run,true);
  }

  public static VirtualFileSystem getVFSForProtocol(String protocol)
  {
    return editFileDialog;
  }
}
