package kudos.ide.tools;

import java.io.*;
import java.util.*;
import javax.swing.*;

import kudos.ide.form.*;

public class Util
{
  private static Hashtable menus = new Hashtable();
  private static Hashtable icons = new Hashtable();

  public static int getLeadingWhiteSpaceWidth(String str, int tabSize)
  {
    int whitespace = 0;
  loop:		for(int i = 0; i < str.length(); i++)
  {
    switch(str.charAt(i))
    {
    case ' ':
      whitespace++;
      break;
    case '\t':
      whitespace += (tabSize - whitespace % tabSize);
      break;
    default:
      break loop;
    }
  }
    return whitespace;
  }

  public static String constructPath(String parent, String path)
  {
    if(path.startsWith(File.separator))
      return canonPath(path);
    else if(path.length() >= 3 && path.charAt(1) == ':')
      return canonPath(path);
    else if(parent == null)
      parent = System.getProperty("user.dir");
    if(parent.endsWith(File.separator))
      return canonPath(parent + path);
    else
      return canonPath(parent + File.separator + path);
  }

  public static String getFileName(String path)
  {
    int count = Math.max(0,path.length() - 2);
    int index = path.lastIndexOf(File.separatorChar,count);
    if(index == -1)
      index = path.lastIndexOf('/',count);

    return path.substring(index + 1);
  }

  public static String getFileParent(String path)
  {
    int count = Math.max(0,path.length() - 2);
    int index = path.lastIndexOf(File.separatorChar,count);
    if(index == -1)
      index = path.lastIndexOf('/',count);

    return path.substring(0,index + 1);
  }

  private static String canonPath(String path)
  {
    try
    {
      return new File(path).getCanonicalPath();
    }
    catch(IOException io)
    {
      return path;
    }
  }

  public static String createWhiteSpace(int len, int tabSize)
  {
    StringBuffer buf = new StringBuffer();
    if(tabSize == 0)
    {
      while(len-- > 0)
	buf.append(' ');
    }
    else		
    {
      int count = len / tabSize;
      while(count-- > 0)
	buf.append('\t');
      count = len % tabSize;
      while(count-- > 0)
	buf.append(' ');
    }
    return buf.toString();
  }

  public static int getLeadingWhiteSpace(String str)
  {
    int whitespace = 0;
  loop:		for(;whitespace < str.length();)
  {
    switch(str.charAt(whitespace))
    {
    case ' ': case '\t':
      whitespace++;
      break;
    default:
      break loop;
    }
  }
    return whitespace;
  }

  public static int getTrailingWhiteSpace(String str)
  {
    int whitespace = 0;
  loop:		for(int i = str.length() - 1; i >= 0; i--)
  {
    switch(str.charAt(i))
    {
    case ' ': case '\t':
      whitespace++;
      break;
    default:
      break loop;
    }
  }
    return whitespace;
  }
}
