package kudos.jvm;

import java.lang.reflect.*;
import java.util.Hashtable;
import java.util.*;

public class KudosClass
{
  //////////////////////////////////////////////////////////////////////////////
  // Description : String Ÿ classname static field ϴ ޽
  // return      : Field[]
  //////////////////////////////////////////////////////////////////////////////
  public Field[] getStatic(String classname) throws ClassNotFoundException
  {
    Class c = Class.forName(classname);
    Field[] fields = c.getDeclaredFields();
    Hashtable staticFields = new Hashtable();

    for (int i=0; i<fields.length; i++)
    {
      Field field = fields[i];
      if ( Modifier.isStatic(field.getModifiers()) )
      {
	staticFields.put(fields[i].getName(), fields[i]);
      }
    }

    Field[] returnStaticFields = new Field[staticFields.size()];

    Enumeration en = staticFields.elements();

    int fieldCount = 0;
    while (en.hasMoreElements())
    {
      returnStaticFields[fieldCount] = (Field)(en.nextElement());
      fieldCount++;
    }

    return returnStaticFields;
  } // end of method "getStatic"

  //////////////////////////////////////////////////////////////////////////////
  // Description : String Ÿ classname staticFieldName  ϴ
  //               ޽
  // return      : void
  //////////////////////////////////////////////////////////////////////////////
  public void setStatic(String classname, String staticFieldName, Object obj) throws ClassNotFoundException
  {
    Class c = Class.forName(classname);
    Field field = null;

    try
    {
      field = c.getDeclaredField(staticFieldName);
    }
    catch(NoSuchFieldException e)
    {
      System.out.println("No Such Field Exception");
    }

    try
    {
      field.set(null, obj); // if field is not public, throws IllegalAccessException
    }
    catch(IllegalAccessException e)
    {
      System.out.println("Illegal Access Exception");
    }

    ///////////////////////////////////////////////////////////////////////////
    // setStatic  Ǿ checkϱ  ڵ
    try
    {
      field = c.getDeclaredField(staticFieldName);
    }
    catch(NoSuchFieldException e)
    {
      System.out.println(e);
    }

    try
    {
      Object val = field.get(c);
      System.out.println(val.toString());
    }
    catch(IllegalAccessException e)
    {
      System.out.println(e);
    }
    //////////////////////////////////////////////////////////////////////////
  } // end of method "setStatic"

  //////////////////////////////////////////////////////////////////////////////
  // Description : ־ class field Ʈ ִ ޽
  // Return      : Field[]
  //////////////////////////////////////////////////////////////////////////////
  public Field[] getFields(Class theClass) throws ClassNotFoundException
  {
    Field[] fields = theClass.getDeclaredFields();

    return fields;

  } // end of getFields()

  //////////////////////////////////////////////////////////////////////////////
  // Description : ־ class method Ʈ ִ ޽
  // Return      : Method[]
  //////////////////////////////////////////////////////////////////////////////
  public Method[] getMethods(Class theClass) throws ClassNotFoundException
  {
    Method[] methods = theClass.getDeclaredMethods();

    return methods;


  } // end of getMethods()

}










