package kudos.jvm;

import java.lang.reflect.*;

public class KudosObject
{

  /**
   *
   */
  public Field[] getObjectField(Object objectname) {
    Class c = objectname.getClass();
    Field[] fields = c.getDeclaredFields();

    return fields;
  }

  public void setObjectField(Object objectname, String fieldname, 
			     Object obj)
  {
    Class c = objectname.getClass();
    Field field = null;

    try {
      field = c.getDeclaredField(fieldname);
    } catch (NoSuchFieldException e) {
      System.out.println("No Such Field Exception");
    }

    try {
      // if field is not public, throws IllegalAccessException
      field.set(objectname, obj); 
    } catch(IllegalAccessException e) {
      System.out.println("Illegal Access Exception");
    }
  }

  /**
   * Creates an object of the specified class and returns it.
   */
  public Object createObject(KudosClassLoader kudosClassLoader, 
			     String classname, String objectname, 
			     Object[] args) throws ClassNotFoundException
  {
    Class instantiatableClass = kudosClassLoader.findClass(classname);
    Object instantiatedObject = null;

    boolean isLoadedClass = true;

    // instantiatableClass JVM  ʴ 
    if (instantiatableClass == null) {
      isLoadedClass = false;
      instantiatableClass = kudosClassLoader.loadClass(classname);
    }

    instantiatableClass = Class.forName(classname);

    Class[] parameterType = new Class[args.length];
    for (int index=0; index < args.length; index++) {
      parameterType[index] = args[index].getClass();
      System.out.println(parameterType[index].getName());
      
      if (parameterType[index].getName().equals("java.lang.Double")) {
	//parameterType[index] = (new Integer(0)).getClass();
	//args[index] = new Integer(((Double) args[index]).intValue());
	parameterType[index] = int.class;
	args[index] = new Integer(((Double) args[index]).intValue());
      }
      /*if (parameterType[index].getName().equals("java.lang.Integer")) {
        parameterType[index] = int.class;
      }
      else if ( parameterType[index].getName().equals("java.lang.Long")) {
        parameterType[index] = long.class;
      }
      else if ( parameterType[index].getName().equals("java.lang.Float")) {
        parameterType[index] = float.class;
      }
      else if ( parameterType[index].getName().equals("java.lang.Double")) {
        parameterType[index] = double.class;
      }
      else if (parameterType[index].getName().equals("java.lang.Character")) {
        parameterType[index] = char.class;
      }
      else if (parameterType[index].getName().equals("java.lang.Boolean")) {
        parameterType[index] = boolean.class;
	}*/
    }

    Constructor constructor = null;
    try {
      if (args.length > 0) {
	constructor = instantiatableClass.getConstructor(parameterType);
      }
      else {
	constructor = instantiatableClass.getConstructor(new Class[0]);
      }
    } catch(NoSuchMethodException e) {
      System.out.println(e);
    } catch (SecurityException e) {
      System.out.println(e);
    }

    try {
      instantiatedObject = constructor.newInstance(args);
      //      System.out.println(instantiatedObject.toString());
    } catch (InstantiationException e) {
      System.out.println(e);
    } catch (IllegalAccessException e) {
      System.out.println(e);
    } catch (IllegalArgumentException e) {
      System.out.println(e);
    } catch (InvocationTargetException e) {
      System.out.println(e);
    }

    // putInstance call

    kudosClassLoader.putInstance(classname, objectname, instantiatedObject);

    return instantiatedObject;
  }

  //////////////////////////////////////////////////////////////////////////////
  // Description : ־ object field Ʈ ִ ޽
  // Return      : Field[]
  //////////////////////////////////////////////////////////////////////////////
  public Field[] getFields(Object theObject)
  {
    Class theClass = theObject.getClass();
    Field[] fields = theClass.getDeclaredFields();

    return fields;
  }

  //////////////////////////////////////////////////////////////////////////////
  // Description : ־ object method Ʈ ִ ޽
  // Return      : Method[]
  //////////////////////////////////////////////////////////////////////////////
  public Method[] getMethods(Object theObject)
  {
    Class theClass = theObject.getClass();
    Method[] methods = theClass.getDeclaredMethods();

    return methods;
  }
} // end of class "KudosObject"
