/* -*---------------------------------------------------------
 * Uses: Java 2 Platform SE v1.3
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * InternalNode.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. ETRI-CSTL. All lefts reserved.
 *
 * $Log$
 */

package kudos.jvm.util;

import java.util.*;


/**
 * Represents an internal node of a tree.
 *
 * @author Cheoljoo Jeong
 */
public class InternalNode extends ClassTreeNode {
  Vector childNodes;
  
  /**
   * constructor
   */
  public InternalNode(ClassTreeNode[] nodes) {
    childNodes = new Vector();
    for (int i = 0; i < nodes.length; i++) {
      childNodes.add(nodes[i]);
    }
  }

  /**
   * Returns the array of child nodes.
   */
  public ClassTreeNode[] getChildNodes() {
    Enumeration e = childNodes.elements();
    ClassTreeNode[] nodes = new ClassTreeNode[childNodes.size()];
    
    int i = 0;
    while (e.hasMoreElements()) {
      nodes[i] = (ClassTreeNode) e.nextElement();
      i++;
    }

    return nodes;
  }

  /**
   * Add the child to the current node.
   */
  public void addChild(ClassTreeNode node) {
    childNodes.add(node);
  }

  /**
   * Removes the child of the current node.
   * 
   */
  public void removeChild(ClassTreeNode node) {
    if (childNodes.contains(node)) {
      childNodes.remove(node);
    }
  }

  /**
   * Visitor method.
   */
  public Object accept(ClassTreeNodeVisitorI visitor) {
    return visitor.visitInternalNode(this);
  }
  
}
