/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * Binding.java:
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.lang;

import kudos.exns.*;

/**
 * A set of bindings constitutes an environment.
 * Formally, a binding is defined to be a pair of a name and
 * a location.
 *
 * @author Cheoljoo Jeong
 */

public class Binding {
  private String key;
  private Object value;
  
  /**
   * constructor
   */
  public Binding(String key) {
    this.key = key;
  }

  /**
   * constructor
   */
  public Binding(String key, Object value) {
    this.key = key;
    this.value = value;
  }

  /**
   * Mutates the value of the binding.
   */
  public void setValue(Object value) {
    this.value = value;
  }

  /**
   * Returns the value of the binding.
   */
  public Object getValue() {
    return value;
  }

  /**
   * Returns the value of the key.
   */
  public String getKey() {
    return key;
  }
}

