/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * Continuation.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.lang;

import kudos.exns.*;

/**
 * A contination is `the operations remaining to be performed' 
 * and can be considered to be a control information explicitly
 * represented.
 * A continuation is simply a special closure object containing
 * a reference to the current frame and hence the entire control
 * stack.
 *
 * @author Cheoljoo Jeong
 */

public abstract class Continuation implements ResumableI {
  //  private CallFrame currentFrame;
  public Environment r;
  public Continuation k;

  /**
   * Constructor
   */
  public Continuation(Environment r, Continuation k) {
    this.r = r;
    this.k = k;
  }

  /**
   * Resumes the suspended computation.
   */
  public abstract Object resume(Object v);
}
