/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * Expr.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.lang;

import kudos.exns.*;

/**
 * Expr class represents an expression of Scheme. We are using
 * 'composite' design pattern for this class and its subclasses.
 *
 * @author Cheoljoo Jeong
 */

public abstract class Expr {
  
  /**
   * The 'eval' method is a major ingredient for Visitor pattern.
   * In [GoF] 'eval' is named 'accept.'
   */
  public Object eval(ExprVisitorI visitor, Environment r, Continuation k) 
    throws SchemeJException
  {
    try {
      return visitor.visitExpr(this, r, k);
    } catch (SchemeJException e) {
      throw e;
    }
  }

  /**
   * Returns the expression type; i.e. returns the expression type id
   * that tells whether this expression is a variable reference, or
   * a lambda expression, or a set! expression, ...
   */
  public abstract int getExprType();
}
