/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * ExprVisitor.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.lang;

import kudos.exns.*;

/**
 * Visitor interface for expressions (ExprI class). 
 *
 * @author Cheoljoo Jeong
 */

public interface ExprVisitorI {

  /**
   * Visits an expression.
   * Instead of using multiple 'visit' methods 
   * (visitVarRefExpr, visitLambdaExpr, visitIfExpr, ...,), 
   * we have chosen to use single 'visit' method
   * which uses ExprI.getExprType() method which tells us 
   * what expression to visit.
   */
  public Object visitExpr(Expr expr, Environment r, Continuation k)
    throws SchemeJException;
}

