/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * Form.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.lang;

import kudos.exns.*;

/**
 * Form class represents definitions and syntax definitions of
 * Scheme. 
 *
 * @author Cheoljoo Jeong
 */

public abstract class Form {
  
  /**
   * The 'eval' method is a major ingredient for Visitor pattern.
   * In [GoF] 'eval' is named 'accept.'
   */
  public Object eval(ExprVisitorI visitor, Environment r, Continuation k) 
    throws SchemeJException
  {
    try {
      return visitor.visitForm(this, r, k);
    } catch (SchemeJException e) {
      throw e;
    }
  }

  /**
   * Returns the form type; i.e. returns the form type id
   * that tells whether this expression is a definition or a
   * syntax definition.
   */
  public abstract int getFormType();
}
