/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * NullEnvironment.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.lang;

import java.util.*;
import kudos.exns.*;

/**
 * NullEnvironment is an empty environment.
 *
 * @author Cheoljoo Jeong
 */

public class NullEnvironment extends Environment {

  /**
   * constructor
   */
  public NullEnvironment() {
    super(null);
  }

  /**
   * Returns the base environment.
   */
  public static Environment getBaseEnv() {
    return Environment.globalEnv;
  }

  /**
   * Finds the binding for the given variable and returns the
   * associated value.
   */
  public Object lookup(String name) throws UnboundVarException {
    throw new UnboundVarException("Unbound var: " + name);
  }


  /**
   * Resumes the suspended computation
   */
  public Object resume(Object v) {
    // failure continuation
    return null;
  }
}
