/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * Procedure.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.lang;

import kudos.exns.*;

/**
 * A closure is a denotation of procedures and standard operators.
 * Two important categories of subclasses of Procedure is Closure and 
 * kudos.schemej.stdlib.* classes.
 *
 * @author Cheoljoo Jeong
 */

public abstract class Procedure {
  /**
   * Accepts a set of arguments and returns the result of applying
   * the corresponding procedure.
   */
  public abstract Object apply(ExprVisitorI visitor, Object[] arguments, 
			       Environment r, Continuation k) 
    throws SchemeJException;

  /**
   * Returns true if the given number is the same as the arity of the
   * procedure that the closure represents.
   */
  public boolean checkArity(int num) {
    return true;
  }
}

