/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * RegisterSet.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.lang;

import kudos.exns.*;

/**
 * A RegisterSet object is the set of five registers 
 * representing the state of a computation.
 * For details, see chapter 3 of Dybvig's thesis, "Three 
 * implementation models for scheme."
 *
 * @author Cheoljoo Jeong
 */

public class RegisterSet {
  public Object a;       // accumulator
  public Expr x;         // next expression
  public Environment e;  // active lexical bindings
  //  public ValueRib r;     // list of arguments evaluated so far
  public Object r;
  public CallFrame s;    // ptr to the top call frame

  /**
   * constructor
   */
  public RegisterSet() {
    a = null;
    x = null;
    e = null;
    r = null;
    s = null;
  }

  /**
   * constructor
   */
  public RegisterSet(Object a, Expr x, Environment e, Object r, CallFrame s) 
  {
    this.a = a;
    this.x = x;
    this.e = e;
    this.r = r;
    this.s = s;
  }

}
