/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * BeginContinuation.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej;

import kudos.lang.*;
import kudos.exns.*;

/**
 * A contination is `the operations remaining to be performed' 
 * and can be considered to be a control information explicitly
 * represented.
 *
 * @author Cheoljoo Jeong
 */

public class BeginContinuation extends Continuation {
  private Expr[] exprs;

  /**
   * constructor
   */
  public BeginContinuation(Expr[] exprs, Environment r, Continuation k) 
  {
    super(r, k);
    this.exprs = new Expr[exprs.length];
    for (int i = 0; i < exprs.length; i++) {
      this.exprs[i] = exprs[i];
    }
  }

  /**
   * Resumes the begin continutation.
   */
  public Object resume(Object v) {
    try {
      Object value = null;
      int len = exprs.length;
      for (int i = 0; i < len; i++) {
	value = exprs[i].eval(Evaluator.evaluator, r, 
			      new PrintErrorContinuation(r, k));
      }
      // returns the value of the last expression
      return k.resume(value);
    } catch (SchemeJException e) {
      return k.resume(e);
    }
  }
}


