/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * BeginExpr.java: AST node for begin expressions
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej;

import kudos.lang.*;
import kudos.exns.*;


/**
 * Represents sequence expressions.
 *
 * @author Cheoljoo Jeong
 */

public class BeginExpr extends Expr {
  public Expr[] exprs;

  /**
   * constructor
   */
  public BeginExpr(Expr[] exprs) {
    this.exprs = new Expr[exprs.length];
    for (int i = 0; i < exprs.length; i++) {
      this.exprs[i] = exprs[i];
    }
  }

  /**
   * Returns the expression type.
   */
  public int getExprType() {
    return ExprType.TBeginExpr;
  }
}



