/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * CaseExpr.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej;

import kudos.lang.*;
import kudos.exns.*;

/**
 * Represents case expressions.
 * Form: (case <key> <clause_1> <clause_2>)
 *
 * @author Cheoljoo Jeong
 */

public class CaseExpr extends Expr {
  Expr key;
  CaseClauseExpr[] clauses;
  
  /**
   * constructor
   */
  public CaseExpr(Expr key, CaseClauseExpr[] clauses) {
    this.key = key;
    this.clauses = new CaseClauseExpr[clauses.length];
    for (int i = 0; i < clauses.length; i++) {
      this.clauses[i] = clauses[i];
    }
  }
  
  /**
   * Returns the expression type.
   */
  public int getExprType() {
    return ExprType.TCaseExpr;
  }

}
