/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * ClauseExpr.java: used as subobjects for CondExpr class
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej;

import kudos.lang.*;


/**
 * Represents clause expressions within cond expressions;
 * not a full-fledged expression.
 * Form: (<test> <expr_1> ...) or (<test> => <expr>)
 *
 * @author Cheoljoo Jeong
 */

public class ClauseExpr {
  public Expr test;
  public Expr[] exprs;
  
  /** 
   * constructor
   */
  public ClauseExpr(Expr test, Expr[] exprs) {
    this.test = test;
    
    this.exprs = new Expr[exprs.length];
    for (int i = 0; i < exprs.length; i++) {
      this.exprs[i] = exprs[i];
    }
  }
}
