/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * CondExpr.java:
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej;

import kudos.lang.*;
import kudos.exns.*;


/**
 * Represents (cond <clause_1> <clause_2> ...) expressions,
 * where each <clause_i> should be of the form (<test> <expression>)
 *
 * @author Cheoljoo Jeong
 */

public class CondExpr extends Expr {
  public ClauseExpr[] clauses;
  
  /**
   * constructor
   */
  public CondExpr(ClauseExpr[] clauses) {
    this.clauses = new ClauseExpr[clauses.length];
    for (int i = 0; i < clauses.length; i++) {
      this.clauses[i] = clauses[i];
    }
  }

  /**
   * Returns the expression type.
   */
  public int getExprType() {
    return ExprType.TCondExpr;
  }

}
