/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * DoExpr.java: AST node for do expressions
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej;

import kudos.lang.*;
import kudos.exns.*;

/**
 * Represents do-iteration expressions.
 *
 * @author Cheoljoo Jeong
 */

public class DoExpr extends Expr {
  public DoBindingExpr[] bindings;
  public Expr test;
  public Expr[] body;
  public Expr[] exit;
  
  /**
   * constructor
   */
  public DoExpr(DoBindingExpr[] bindings, Expr test, Expr[] body, 
		Expr[] exit) 
  {
    this.bindings = new DoBindingExpr[bindings.length];
    for (int i = 0; i < bindings.length; i++) {
      this.bindings[i] = bindings[i];
    }

    this.test = test;

    this.body = new Expr[body.length];
    for (int i = 0; i < body.length; i++) {
      this.body[i] = body[i];
    }

    this.exit = new Expr[exit.length];
    for (int i = 0; i < exit.length; i++) {
      this.exit[i] = exit[i];
    }
  }

  /**
   * Returns the expression type.
   */
  public int getExprType() {
    return ExprType.TApplyExpr;
  }
}
