/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * IfExprf.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej;

import kudos.lang.*;
import kudos.exns.*;

/**
 * Represents conditional expressions.
 *
 * @author Cheoljoo Jeong
 */

public class IfExpr extends Expr {
  public Expr condExpr;
  public Expr thenExpr;
  public Expr elseExpr;


  /**
   * constructor
   */
  public IfExpr(Expr condExpr, Expr thenExpr) {
    this.condExpr = condExpr;
    this.thenExpr = thenExpr;
    this.elseExpr = null;
  }

  /**
   * constructor
   */
  public IfExpr(Expr condExpr, Expr thenExpr, Expr elseExpr) {
    this.condExpr = condExpr;
    this.thenExpr = thenExpr;
    this.elseExpr = elseExpr;
  }
  
  /**
   * Returns the expression type.
   */
  public int getExprType() {
    return ExprType.TIfExpr;
  }

}

