/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * LambdaExpr.java: AST node for lambda expressions
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej;

import kudos.lang.*;


/**
 * Represents procedure definitions.
 *
 * @author Cheoljoo Jeong
 */

public class LambdaExpr extends Expr {
  public String funcname;
  public String[] formals;
  public Expr body;

  /**
   * constructor
   */
  public LambdaExpr(String[] formals, Expr body) {
    this.funcname = "";
    this.body = body;

    this.formals = new String[formals.length];
    for (int i = 0; i < formals.length; i++) {
      this.formals[i] = formals[i];
    }
  }

  /**
   * Constructor.
   * 'funcname' is needed for dealing with recursive procedure definition. 
   */
  public LambdaExpr(String funcname, String[] formals, Expr body) {
    this.funcname = funcname;
    this.body = body;
    this.formals = new String[formals.length];
    for (int i = 0; i < formals.length; i++) {
      this.formals[i] = formals[i];
    }
  }

  /**
   * Returns the expression type.
   */
  public int getExprType() {
    return ExprType.TLambdaExpr;
  }
}
