/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * LetExpr.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej;

import kudos.lang.*;
import kudos.exns.*;


/**
 * Represents let expressions;
 * let expressions are one of two main binding forms: let & lambda
 *
 * @author Cheoljoo Jeong
 */

public class LetExpr extends Expr {
  public static String notNamed = "notnamed";

  public String name;         // for named-let expresions
  public BindingExpr[] decls;
  public Expr body;

  /**
   * constructor for normal let expressions
   */
  public LetExpr(BindingExpr[] decls, Expr body) {
    this.name = new String(notNamed);
    this.decls = new BindingExpr[decls.length];
    for (int i = 0; i < decls.length; i++) {
      this.decls[i] = decls[i];
    }
    this.body = body;
  }

  /**
   * constructor for named-let expressions
   */
  public LetExpr(String name, BindingExpr[] decls, Expr body) {
    this.name = name;
    this.decls = new BindingExpr[decls.length];
    for (int i = 0; i < decls.length; i++) {
      this.decls[i] = decls[i];
    }
    this.body = body;
  }

  /**
   * Returns true iff this let expressions is named.
   */
  public boolean isNamedLet() {
    if (name.equals(notNamed)) {
      return false;
    }
    else {
      return true;
    }
  }
  
  /**
   * Returns the expression type.
   */
  public int getExprType() {
    return ExprType.TLetExpr;
  }

}
