/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * LetStarExpr.java: AST node for let* expressions
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej;

import kudos.lang.*;
import kudos.exns.*;

/**
 * Represents let* expressions, which is similar to let
 * expressions except that, in let* expressions, declarations
 * are evaluated from left to right.
 *
 * @author Cheoljoo Jeong
 */

public class LetStarExpr extends LetExpr {
  
  /** 
   * constructor
   */
  public LetStarExpr(BindingExpr[] decls, Expr body) {
    super(decls, body);
  }

  /**
   * Returns the expression type.
   */
  public int getExprType() {
    return ExprType.TLetStarExpr;
  }

}











