/* -*---------------
 * Uses: JLex 1.2.5
 * -*---------------
 * @(#) $Id$
 *
 * SchemeJ.lex: JLex specficiation for SchemeJ
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */
package kudos.schemej;
import java.io.*;
import kudos.schemej.util.*;


public class Lexer implements java_cup.runtime.Scanner {
	private final int YY_BUFFER_SIZE = 512;
	private final int YY_F = -1;
	private final int YY_NO_STATE = -1;
	private final int YY_NOT_ACCEPT = 0;
	private final int YY_START = 1;
	private final int YY_END = 2;
	private final int YY_NO_ANCHOR = 4;
	private final int YY_BOL = 128;
	private final int YY_EOF = 129;

  private java_cup.runtime.Symbol tok(int k, Object value) {
    if (k == sym.SYMBOL) {
      SSymbol val = new SSymbol(k, (String) value);
      java_cup.runtime.Symbol sym = 
	new java_cup.runtime.Symbol(k, -1, -1, val);
      return sym;
    }
    else if (k == sym.NUMBER) {
      SNumber val = new SNumber(k, (Double) value);
      java_cup.runtime.Symbol sym = 
	new java_cup.runtime.Symbol(k, -1, -1, val);
      return sym;
    }
    else if (k == sym.STRING) {
      SSymbol val = new SSymbol(k, (String) value);
      java_cup.runtime.Symbol sym = 
	new java_cup.runtime.Symbol(k, -1, -1, val);
      return sym;
    }
    else if (k == sym.CHAR) {
      String charstr = (String) value;
      SSymbol val = new SSymbol(k, charstr.substring(charstr.length()-1));
      java_cup.runtime.Symbol sym = 
	new java_cup.runtime.Symbol(k, -1, -1, val);
      return sym;
    }
    else if (k == sym.QUOTE) {
      SSymbol val = new SSymbol(k, (String) value);
      java_cup.runtime.Symbol sym =
	new java_cup.runtime.Symbol(k, -1, -1, val);
      return sym;
    }
    else if (k == sym.DOT) {
      SSymbol val = new SSymbol(k, (String) value);
      java_cup.runtime.Symbol sym =
	new java_cup.runtime.Symbol(k, -1, -1, val);
      return sym;
    }
    else {
      java_cup.runtime.Symbol sym = 
	new java_cup.runtime.Symbol(k, -1, -1, value);
      return sym;
    }
  }
	private java.io.BufferedReader yy_reader;
	private int yy_buffer_index;
	private int yy_buffer_read;
	private int yy_buffer_start;
	private int yy_buffer_end;
	private char yy_buffer[];
	private int yychar;
	private int yyline;
	private boolean yy_at_bol;
	private int yy_lexical_state;

	public Lexer (java.io.Reader reader) {
		this ();
		if (null == reader) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(reader);
	}

	public Lexer (java.io.InputStream instream) {
		this ();
		if (null == instream) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(new java.io.InputStreamReader(instream));
	}

	private Lexer () {
		yy_buffer = new char[YY_BUFFER_SIZE];
		yy_buffer_read = 0;
		yy_buffer_index = 0;
		yy_buffer_start = 0;
		yy_buffer_end = 0;
		yychar = 0;
		yyline = 0;
		yy_at_bol = true;
		yy_lexical_state = YYINITIAL;
	}

	private boolean yy_eof_done = false;
	private final int YYINITIAL = 0;
	private final int COMMENT = 1;
	private final int yy_state_dtrans[] = {
		0,
		17
	};
	private void yybegin (int state) {
		yy_lexical_state = state;
	}
	private int yy_advance ()
		throws java.io.IOException {
		int next_read;
		int i;
		int j;

		if (yy_buffer_index < yy_buffer_read) {
			return yy_buffer[yy_buffer_index++];
		}

		if (0 != yy_buffer_start) {
			i = yy_buffer_start;
			j = 0;
			while (i < yy_buffer_read) {
				yy_buffer[j] = yy_buffer[i];
				++i;
				++j;
			}
			yy_buffer_end = yy_buffer_end - yy_buffer_start;
			yy_buffer_start = 0;
			yy_buffer_read = j;
			yy_buffer_index = j;
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}

		while (yy_buffer_index >= yy_buffer_read) {
			if (yy_buffer_index >= yy_buffer.length) {
				yy_buffer = yy_double(yy_buffer);
			}
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}
		return yy_buffer[yy_buffer_index++];
	}
	private void yy_move_end () {
		if (yy_buffer_end > yy_buffer_start &&
		    '\n' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
		if (yy_buffer_end > yy_buffer_start &&
		    '\r' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
	}
	private boolean yy_last_was_cr=false;
	private void yy_mark_start () {
		int i;
		for (i = yy_buffer_start; i < yy_buffer_index; ++i) {
			if ('\n' == yy_buffer[i] && !yy_last_was_cr) {
				++yyline;
			}
			if ('\r' == yy_buffer[i]) {
				++yyline;
				yy_last_was_cr=true;
			} else yy_last_was_cr=false;
		}
		yychar = yychar
			+ yy_buffer_index - yy_buffer_start;
		yy_buffer_start = yy_buffer_index;
	}
	private void yy_mark_end () {
		yy_buffer_end = yy_buffer_index;
	}
	private void yy_to_mark () {
		yy_buffer_index = yy_buffer_end;
		yy_at_bol = (yy_buffer_end > yy_buffer_start) &&
		            ('\r' == yy_buffer[yy_buffer_end-1] ||
		             '\n' == yy_buffer[yy_buffer_end-1] ||
		             2028/*LS*/ == yy_buffer[yy_buffer_end-1] ||
		             2029/*PS*/ == yy_buffer[yy_buffer_end-1]);
	}
	private java.lang.String yytext () {
		return (new java.lang.String(yy_buffer,
			yy_buffer_start,
			yy_buffer_end - yy_buffer_start));
	}
	private int yylength () {
		return yy_buffer_end - yy_buffer_start;
	}
	private char[] yy_double (char buf[]) {
		int i;
		char newbuf[];
		newbuf = new char[2*buf.length];
		for (i = 0; i < buf.length; ++i) {
			newbuf[i] = buf[i];
		}
		return newbuf;
	}
	private final int YY_E_INTERNAL = 0;
	private final int YY_E_MATCH = 1;
	private java.lang.String yy_error_string[] = {
		"Error: Internal error.\n",
		"Error: Unmatched input.\n"
	};
	private void yy_error (int code,boolean fatal) {
		java.lang.System.out.print(yy_error_string[code]);
		java.lang.System.out.flush();
		if (fatal) {
			throw new Error("Fatal Error.\n");
		}
	}
	private int[][] unpackFromString(int size1, int size2, String st) {
		int colonIndex = -1;
		String lengthString;
		int sequenceLength = 0;
		int sequenceInteger = 0;

		int commaIndex;
		String workString;

		int res[][] = new int[size1][size2];
		for (int i= 0; i < size1; i++) {
			for (int j= 0; j < size2; j++) {
				if (sequenceLength != 0) {
					res[i][j] = sequenceInteger;
					sequenceLength--;
					continue;
				}
				commaIndex = st.indexOf(',');
				workString = (commaIndex==-1) ? st :
					st.substring(0, commaIndex);
				st = st.substring(commaIndex+1);
				colonIndex = workString.indexOf(':');
				if (colonIndex == -1) {
					res[i][j]=Integer.parseInt(workString);
					continue;
				}
				lengthString =
					workString.substring(colonIndex+1);
				sequenceLength=Integer.parseInt(lengthString);
				workString=workString.substring(0,colonIndex);
				sequenceInteger=Integer.parseInt(workString);
				res[i][j] = sequenceInteger;
				sequenceLength--;
			}
		}
		return res;
	}
	private int yy_acpt[] = {
		/* 0 */ YY_NO_ANCHOR,
		/* 1 */ YY_NO_ANCHOR,
		/* 2 */ YY_NO_ANCHOR,
		/* 3 */ YY_NO_ANCHOR,
		/* 4 */ YY_NO_ANCHOR,
		/* 5 */ YY_NO_ANCHOR,
		/* 6 */ YY_NO_ANCHOR,
		/* 7 */ YY_NO_ANCHOR,
		/* 8 */ YY_NO_ANCHOR,
		/* 9 */ YY_NO_ANCHOR,
		/* 10 */ YY_NOT_ACCEPT,
		/* 11 */ YY_NO_ANCHOR,
		/* 12 */ YY_NO_ANCHOR,
		/* 13 */ YY_NO_ANCHOR,
		/* 14 */ YY_NO_ANCHOR,
		/* 15 */ YY_NO_ANCHOR,
		/* 16 */ YY_NO_ANCHOR,
		/* 17 */ YY_NOT_ACCEPT,
		/* 18 */ YY_NO_ANCHOR,
		/* 19 */ YY_NO_ANCHOR,
		/* 20 */ YY_NO_ANCHOR,
		/* 21 */ YY_NO_ANCHOR
	};
	private int yy_cmap[] = unpackFromString(1,130,
"12:9,13,10,12:2,0,12:18,13,6,8,4,6:3,3,1,2,6:4,7,6,9:10,6,11,6:32,5,6,12:3," +
"6:13,14,6:12,12:3,6,12,15:2")[0];

	private int yy_rmap[] = unpackFromString(1,22,
"0,1:3,2,1,3,1:3,4,1,5,1:2,6,7,8,9,3,5,10")[0];

	private int yy_nxt[][] = unpackFromString(11,16,
"-1,1,2,3,4,5,16,6,21,15,7,8,5,7,16,9,-1:20,16,10,16:4,-1:4,16,-1:5,16,-1,16" +
":3,19,-1:4,16,-1:5,11,-1,11:4,-1:4,11,-1:5,20,-1,20:2,12,20,-1:4,20,-1:5,16" +
",-1,16,19,16,15,-1:4,16,-1:5,16,-1,16:4,-1:4,16,-1:2,13:4,18,13:4,-1,13:4,9" +
",-1:14,14,-1:5,20,-1,20:4,-1:4,20,-1");

	public java_cup.runtime.Symbol next_token ()
		throws java.io.IOException {
		int yy_lookahead;
		int yy_anchor = YY_NO_ANCHOR;
		int yy_state = yy_state_dtrans[yy_lexical_state];
		int yy_next_state = YY_NO_STATE;
		int yy_last_accept_state = YY_NO_STATE;
		boolean yy_initial = true;
		int yy_this_accept;

		yy_mark_start();
		yy_this_accept = yy_acpt[yy_state];
		if (YY_NOT_ACCEPT != yy_this_accept) {
			yy_last_accept_state = yy_state;
			yy_mark_end();
		}
		while (true) {
			if (yy_initial && yy_at_bol) yy_lookahead = YY_BOL;
			else yy_lookahead = yy_advance();
			yy_next_state = YY_F;
			yy_next_state = yy_nxt[yy_rmap[yy_state]][yy_cmap[yy_lookahead]];
			if (YY_EOF == yy_lookahead && true == yy_initial) {

  { return tok(sym.EOF, null); }
			}
			if (YY_F != yy_next_state) {
				yy_state = yy_next_state;
				yy_initial = false;
				yy_this_accept = yy_acpt[yy_state];
				if (YY_NOT_ACCEPT != yy_this_accept) {
					yy_last_accept_state = yy_state;
					yy_mark_end();
				}
			}
			else {
				if (YY_NO_STATE == yy_last_accept_state) {
					throw (new Error("Lexical Error: Unmatched Input."));
				}
				else {
					yy_anchor = yy_acpt[yy_last_accept_state];
					if (0 != (YY_END & yy_anchor)) {
						yy_move_end();
					}
					yy_to_mark();
					switch (yy_last_accept_state) {
					case 0:
						{ return tok(sym.NUMBER, new Double(yytext())); }
					case -2:
						break;
					case 1:
						{ return tok(sym.LPAREN, (String) "("); }
					case -3:
						break;
					case 2:
						{ return tok(sym.RPAREN, (String) ")"); }
					case -4:
						break;
					case 3:
						{ return tok(sym.QUOTE, (String) "quote"); }
					case -5:
						break;
					case 4:
						{ return tok(sym.SYMBOL, yytext()); }
					case -6:
						break;
					case 5:
						{}
					case -7:
						break;
					case 6:
						{ return tok(sym.DOT, yytext()); }
					case -8:
						break;
					case 7:
						{}
					case -9:
						break;
					case 8:
						{ yybegin(COMMENT); }
					case -10:
						break;
					case 9:
						
					case -11:
						break;
					case 11:
						{ return tok(sym.CHAR, yytext()); }
					case -12:
						break;
					case 12:
						{ return tok(sym.STRING, yytext()); }
					case -13:
						break;
					case 13:
						{}
					case -14:
						break;
					case 14:
						{ yybegin(YYINITIAL); }
					case -15:
						break;
					case 15:
						{ return tok(sym.NUMBER, new Double(yytext())); }
					case -16:
						break;
					case 16:
						{ return tok(sym.SYMBOL, yytext()); }
					case -17:
						break;
					case 18:
						{}
					case -18:
						break;
					case 19:
						{ return tok(sym.NUMBER, new Double(yytext())); }
					case -19:
						break;
					case 20:
						{ return tok(sym.SYMBOL, yytext()); }
					case -20:
						break;
					case 21:
						{ return tok(sym.SYMBOL, yytext()); }
					case -21:
						break;
					default:
						yy_error(YY_E_INTERNAL,false);
					case -1:
					}
					yy_initial = true;
					yy_state = yy_state_dtrans[yy_lexical_state];
					yy_next_state = YY_NO_STATE;
					yy_last_accept_state = YY_NO_STATE;
					yy_mark_start();
					yy_this_accept = yy_acpt[yy_state];
					if (YY_NOT_ACCEPT != yy_this_accept) {
						yy_last_accept_state = yy_state;
						yy_mark_end();
					}
				}
			}
		}
	}
}
