/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * Macro.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej;

import kudos.exns.*;
import kudos.schemej.util.*;

/**
 * A macro is a program-defined expression type.
 *
 * @author Cheoljoo Jeong
 */

public class Macro extends Procedure {
  public String[] params;     // parameter names
  public Expr body;           // function body
  public Environment env;     // enclosing environment


  /**
   * constructor
   */
  public Macro(String[] params, Expr body, Environment parent) {
    this.params = new String[params.length];
    for (int i = 0; i < params.length; i++) {
      this.params[i] = params[i];
    }
    this.body = body;
    this.env = new Environment(parent);
  }

  /** 
   * The "apply"
   */
  public Object apply(ExprVisitorI evaluator, Object[] arguments, 
		      Environment r, Continuation k) 
    throws SchemeJException
  {
    try {
      for (int i = 0; i < arguments.length; i++) {
	env.extend(params[i], arguments[i]);
      }
      return body.eval(evaluator, env, k);
    } catch (SchemeJException e) {
      throw e;
    }
  }

  /**
   * Expands the macro.
   */
  public Expr expand(Object[] arguments) throws SchemeJException {
    if (checkArity(arguments.length) == true) {
      
    }
    // if no. args does not match
    else {
      throw new SchemeJException(SchemeJException.EvalError,
				 "Macro expansion error: no. args mismatch");
    }
  }

  /**
   * Returns true if the given number is the same as the arity of the
   * procedure that the closure represents.
   */
  public boolean checkArity(int num) {
    if (num == params.length) {
      return true;
    }
    else {
      return false;
    }
  }
}
