/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * NullContinuation.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej;

import kudos.lang.*;
import kudos.exns.*;

/**
 * A null contination is the empty computation which is used
 * not to indicate the remaining computation but just need
 * the value of some expressions.
 *
 * @author Cheoljoo Jeong
 */

public class NullContinuation extends Continuation {
  /**
   * constructor
   */
  public NullContinuation(Environment r) {
    super(r, null);
  }

  /**
   * Resumes the suspended computation.
   * Do nothing.
   */
  public Object resume(Object v) {
    return v;
  }
}
