/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * PrintErrorContinuation.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej;

import kudos.lang.*;
import kudos.exns.*;

/**
 * A print error contination prints only if the passed
 * value is an Exception.
 *
 * @author Cheoljoo Jeong
 */

public class PrintErrorContinuation extends Continuation {

  /**
   * constructor
   */
  public PrintErrorContinuation(Environment r, Continuation k) {
    super(r, k);
  }

  /**
   * Resumes the suspended computation.
   * Prints the errors.
   */
  public Object resume(Object v) {
    // in case of failure
    if (v instanceof SchemeJException) {
      switch (((SchemeJException) v).getErrorClass()) {
        case SchemeJException.SysError:
	  System.out.println("Error: " + ((SchemeJException) v).getMessage());
	  break;
        case SchemeJException.EvalError:
	  System.out.println("Error: " + ((SchemeJException) v).getMessage());
	  break;
        default:
	  System.out.println("Error: " + ((SchemeJException) v).getMessage());
      }
      //((Exception) v).printStackTrace();
    }
    return v;
  }
}


