/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * QuoteExpr.java:
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej;

import kudos.schemej.util.*;
import kudos.lang.*;
import kudos.exns.*;


/**
 * Represents literal expressions, e.g. (quote <datum>).
 * (quote <datum>) evaluates to <datum>, where <datum> may be
 * any `external representation' of a SchemeJ object.
 *
 * @author Cheoljoo Jeong
 */

public class QuoteExpr extends Expr {
  public SExpr sexpr;

  /**
   * constructor
   */
  public QuoteExpr(SExpr sexpr) {
    this.sexpr = sexpr;
  }

  /**
   * Returns the expression type.
   */
  public int getExprType() {
    return ExprType.TQuoteExpr;
  }
}
