/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * SExprPrinter.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej;

import kudos.schemej.util.*;
import kudos.exns.*;

/**
 * Pretty printer for SExpr objects.
 *
 * @author Cheoljoo Jeong
 */

public class SExprPrinter implements SExprVisitorI {

  /**
   * Visitor method for Atoms.
   */
  public Object visitAtom(Atom atom) {
    switch (atom.getId()) {
      case sym.SYMBOL:
	return atom.getValue();
      case sym.STRING:
	return atom.getValue();
      case sym.CHAR:
	return ("#\\" + atom.getValue());
      case sym.NUMBER:
	return atom.getValue().toString();
      default:
	return atom.getValue();
    }
  }

  /**
   * Visitor method for Pairs.
   */
  public Object visitPair(Pair pair) {
    String str = "(";
    try {
      str = str.concat((String) pair.car.accept(this));
      str = str.concat(" . ");
      
      if (!pair.cdr.isNullList()) {
	str = str.concat((String) pair.cdr.accept(this));
      }
      else {
	str = str.concat("nil");
      }
      
      str = str.concat(")");

      return str;
    } catch (SchemeJException e) {
      return (String) "*error*";
    }
  }

  /**
   * Visitor method for the NullList.
   */
  public Object visitNullList(NullList nullList) {
    return "";
  }
}

