/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * SchemeJEnvironment.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej;

import kudos.schemej.stdlib.*;
import kudos.lang.*;
import kudos.exns.*;

/**
 * SchemeJEnvironment is an Environment class whose instance is
 * constructed initially with the bindings of standard library
 * procedures.
 *
 * @author Cheoljoo Jeong
 */

public class SchemeJEnvironment extends Environment { 
  /**
   * constructor
   */
  public SchemeJEnvironment(Environment prevEnv) {
    super(prevEnv);
    extend("read", new kudos.schemej.stdlib.Read());
    extend("+", new kudos.schemej.stdlib.Add());
    extend("-", new kudos.schemej.stdlib.Subtract());
    extend("*", new kudos.schemej.stdlib.Multiply());
    extend("/", new kudos.schemej.stdlib.Divide());
    extend(">", new kudos.schemej.stdlib.GreaterThan());
    extend(">=", new kudos.schemej.stdlib.GreaterThanEquals());
    extend("=", new kudos.schemej.stdlib.NumEquals());
    extend("<", new kudos.schemej.stdlib.LessThan());
    extend("<=", new kudos.schemej.stdlib.LessThanEquals());
    extend("null", null);
    extend("car", new kudos.schemej.stdlib.Car());
    extend("cdr", new kudos.schemej.stdlib.Cdr());
    extend("cons", new kudos.schemej.stdlib.Cons());
    //extend("call-with-current-continuations", 
    //new kudos.schemej.stdlib.CallCC());
    extend("eqv?", new kudos.schemej.stdlib.EqvP());
    extend("null?", new kudos.schemej.stdlib.NullP());
    extend("symbol?", new kudos.schemej.stdlib.SymbolP());
    extend("pair?", new kudos.schemej.stdlib.PairP());
    extend("boolean?", new kudos.schemej.stdlib.BooleanP());
    extend("number?", new kudos.schemej.stdlib.NumberP());
    extend("string?", new kudos.schemej.stdlib.StringP());
    extend("procedure?", new kudos.schemej.stdlib.ProcedureP());
    extend("class?", new kudos.schemej.stdlib.ClassP());
    extend("interface?", new kudos.schemej.stdlib.InterfaceP());
    extend("implements?", new kudos.schemej.stdlib.ImplementsP());
    extend("=", new kudos.schemej.stdlib.EqualsP());
    extend("load-class", new kudos.schemej.stdlib.LoadClass());
    extend("create-object", new kudos.schemej.stdlib.CreateObject());
    extend("send", new kudos.schemej.stdlib.SendMessage());
    extend("send-static", new kudos.schemej.stdlib.SendStatic());
    extend("get-method", new kudos.schemej.stdlib.GetMethod());
    extend("get-field", new kudos.schemej.stdlib.GetField());
    extend("get-field-value", new kudos.schemej.stdlib.GetFieldValue());
    extend("set-field-value", new kudos.schemej.stdlib.SetFieldValue());
    extend("make-action-listener",
	   new kudos.schemej.stdlib.MakeActionListener());
    extend("eval", new kudos.schemej.stdlib.Eval());
    extend("else", new Boolean(true));
    extend("#t", new Boolean(true));
    extend("#f", new Boolean(false));
  }

}
