/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * JComponent.java:
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej.component;

import kudos.exns.*;
import java.lang.reflect.*;


/**
 * An implementation of JComponentI interface.
 *
 * @author Cheoljoo Jeong
 */
public class JComponent implements JComponentI {
  // We regard that a component has a state which means
  // that it is an `extended object.'
  private Class javaClass;
  private Object javaObject;

  /**
   * constructor
   */
  public JComponent(Class javaClass) {
    this.javaClass = javaClass;
  }

  /**
   * Returns the array of method metaobjects.
   */
  public Method[] getMethods() {
    return javaClass.getMethods();
  }

  /**
   * Returns the array of field metaobjects.
   */
  public Field[] getFileds() {
    return javaClass.getFields();
  }

  /**
   * Invokes the method
   */
  Object invokeMethod(Method method, Object[] arguments) {
    if (beforeMethod != null) {
      Object value = beforeMethod.invoke(javaObject, ...);
    }

    Object value = method.invoke(javaObject, arguments);

    if (afterMethod != null) {
      Object value = afterMethod.invoke(javaObject, ...);
    }

    return value;
  }

  /**
   * Returns the java class wrapped in this component model.
   */
  public Class getJavaClass() {
    return javaClass;
  }
}
