/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * Add.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej.stdlib;

import kudos.lang.*;
import kudos.exns.*;

/**
 * Implements the standard library procedure '+'.
 *
 * @author Cheoljoo Jeong
 */

public class Add extends Procedure {
  /**
   * The "apply"
   */
  public Object apply(ExprVisitorI visitor, Object[] arguments, 
		      Environment r, Continuation k) 
    throws InvalidTypeException 
  {
    double value = 0.0;

    for (int i = 0; i < arguments.length; i++) {
      if (arguments[i] instanceof Double) {
	value += ((Double) arguments[i]).doubleValue();
      }
      else {
	System.out.println(arguments[i].getClass().getName());
	return k.resume(new InvalidTypeException("+ should have " +
						 "number arguments"));
      }
    }
    return k.resume(new Double(value));
  }

  /**
   * Returns true only if the given number is the same as the 
   * arity of the procedure that the closure represents.
   */
  public boolean checkArity(int num) {
    if (num >= 1) {
      return true;
    }
    else {
      return false;
    }
  }
}

