/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * CallCC.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej.stdlib;

import kudos.schemej.*;
import kudos.schemej.util.*;
import kudos.lang.*;
import kudos.exns.*;

/**
 * Implements the standard library procedure 
 * 'call-with-current-continuations'.
 *
 * @author Cheoljoo Jeong
 */

public class CallCC extends Procedure {
  /**
   * The "apply"
   */
  public Object apply(ExprVisitorI visitor, Object[] arguments, 
		      Environment r, Continuation k) 
    throws InvalidTypeException, SchemeJException
  {

    try {
      if (arguments[0] instanceof Expr) {
	Evaluator eval = new Evaluator();
	Expr expr = (Expr) arguments[0];
	Object value = expr.eval(eval, r, k);
	
	return k.resume(value);
      } 
      else {
	return k.resume(new SchemeJException(SchemeJException.EvalError,
					     "car should have list argument"));
      }
    } catch (SchemeJException e) {
      return k.resume(e);
    }
  }

  /**
   * Returns true if the given number is the same as the arity of the
   * procedure that the closure represents.
   */
  public boolean checkArity(int num) {
    if (num == 1) {
      return true;
    }
    else {
      return false;
    }
  }
}

