/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * ClassP.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej.stdlib;

import kudos.schemej.util.*;
import kudos.lang.*;
import kudos.exns.*;

/**
 * Implements the standard library procedure 'class?'.
 * Note!: We can easily implement 'class?' predicate, but how 
 *        can we implement 'object?' predicate? Currently we are 
 *        using 'java.lang.Object' object to represent SchemeJ 
 *        values internally.
 *        So, we need a way to ... Hmm..
 *
 * @author Cheoljoo Jeong
 */

public class ClassP extends Procedure {
  /**
   * The "apply."
   */
  public Object apply(ExprVisitorI visitor, Object[] arguments, 
		      Environment r, Continuation k) 
    throws InvalidTypeException 
  {
    if (arguments[0] instanceof Class) {
      return k.resume(new Boolean(true));
    }
    else {
      return k.resume(new Boolean(false));
    }
  }

  /**
   * Returns true if the given number is the same as the arity of the
   * procedure that the closure represents.
   */
  public boolean checkArity(int num) {
    if (num == 1) {
      return true;
    }
    else {
      return false;
    }
  }
}

