/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * Cons.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej.stdlib;

import kudos.schemej.util.*;
import kudos.lang.*;
import kudos.exns.*;

/**
 * Implements the standard library procedure 'car'.
 *
 * @author Cheoljoo Jeong
 */

public class Cons extends Procedure {
  /**
   * The "apply"
   */
  public Object apply(ExprVisitorI visitor, Object[] arguments, 
		      Environment r, Continuation k) 
    throws InvalidTypeException 
  {
    if (arguments[0] instanceof SExpr) {
      if ((arguments[1] instanceof Pair) ||
	  (arguments[1] instanceof NullList)) 
      {
	Pair pair = new Pair((SExpr) arguments[0], (SExpr) arguments[1]);
	return k.resume(pair);
      }
      else {
	return k.resume(new InvalidTypeException("a cdr should be a cons"));
      }
    }
    else {
      return k.resume(new InvalidTypeException("a car should be either " +
					       "an atom or a cons"));
    }
  }

  /**
   * Returns true if the given number is the same as the arity of the
   * procedure that the closure represents.
   */
  public boolean checkArity(int num) {
    if (num == 2) {
      return true;
    }
    else {
      return false;
    }
  }
}

