/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * Divide.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej.stdlib;

import kudos.lang.*;
import kudos.exns.*;

/**
 * Implements the standard library procedure '/'.
 *
 * @author Cheoljoo Jeong
 */

public class Divide extends Procedure {
  /**
   * The "apply"; it assumes that the number of arguments are
   * correct.
   */
  public Object apply(ExprVisitorI visitor, Object[] arguments, 
		      Environment r, Continuation k) 
    throws InvalidTypeException 
  {
    if ((arguments[0] instanceof Double) && 
	(arguments[1] instanceof Double)) {
      double value1 = ((Double) arguments[0]).doubleValue();
      double value2 = ((Double) arguments[1]).doubleValue();

      return k.resume(new Double(value1 / value2));
    }
    else {
      return k.resume(new InvalidTypeException("/ should have " + 
					       "number arguments"));
    }
  }

  /**
   * Returns true if the given number is the same as the arity of the
   * procedure that the closure represents.
   */
  public boolean checkArity(int num) {
    if (num == 2) {
      return true;
    }
    else
      return false;
  }
}

