/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * EqvP.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej.stdlib;

import kudos.schemej.util.*;
import kudos.lang.*;
import kudos.exns.*;

/**
 * Implements the standard library procedure 'eqv?'.
 *
 * @author Cheoljoo Jeong
 */

public class EqvP extends Procedure {
  /**
   * The "apply."
   * Precondition: the number of arguments are correct
   */
  public Object apply(ExprVisitorI visitor, Object[] arguments, 
		      Environment r, Continuation k) 
    throws InvalidTypeException 
  {
    Object arg1 = arguments[0];
    Object arg2 = arguments[1];

    if (arg1 instanceof Boolean) {
      if (arg2 instanceof Boolean) {
	if (((Boolean) arg1).equals((Boolean) arg2)) {
	  return k.resume(new Boolean(true));
	}
      }
    }
    else if (arg1 instanceof Double) {
      if (arg2 instanceof Double) {
	if (((Double) arg1).equals((Double) arg2)) {
	  return k.resume(new Boolean(true));
	}
      }
    }
    if (arg1 instanceof String) {
      if (arg2 instanceof String) {
	if (((String) arg1).equals((String) arg2)) {
	  return k.resume(new Boolean(true));
	}
      }
    }
    if (arg1 instanceof SSymbol) {
      if (arg2 instanceof SSymbol) {
	if (((SSymbol) arg1).equals((SSymbol) arg2)) {
	  return k.resume(new Boolean(true));
	}
      }
    }

    return k.resume(new Boolean(false));
  }

  /**
   * Returns true if the given number is the same as the arity of the
   * procedure that the closure represents.
   */
  public boolean checkArity(int num) {
    if (num > 0) {
      return true;
    }
    else {
      return false;
    }
  }
}

