/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * Eval.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej.stdlib;

import kudos.schemej.*;
import kudos.schemej.util.*;
import kudos.lang.*;
import kudos.exns.*;

/**
 * Implements the standard library procedure 'eval'.
 * This procedure is extemporaneous!
 * Remove this later when the metacircular architecture is built.
 *
 * @author Cheoljoo Jeong
 */

public class Eval extends Procedure {
  /**
   * The "apply"
   */
  public Object apply(ExprVisitorI visitor, Object[] arguments, 
		      Environment r, Continuation k) 
    throws SchemeJException 
  {
    try {
      String syntax = "(eval 'quoted-expr [env] [cont])";
      Evaluator eval = new Evaluator();
      if (!(arguments[0] instanceof SExpr)) {
	throw new SchemeJException(SchemeJException.EvalError, syntax);
      }

      SExpr sexpr = (SExpr) arguments[0];
      Expr expr = (Expr) sexpr.accept(new SExprParser());
      Environment env = r;
      Continuation cont = k;

      if (arguments.length >= 2) {
	if (!(arguments[1] instanceof Environment)) {
	  throw new SchemeJException(SchemeJException.EvalError, syntax);
	}
	env = (Environment) arguments[1];
      }
      if (arguments.length == 3) {
	if (!(arguments[1] instanceof Continuation)) {
	  throw new SchemeJException(SchemeJException.EvalError, syntax);
	}
	cont = (Continuation) arguments[2];
      }

      Object value = expr.eval(eval, env, cont);
      return k.resume(value);

    } catch (SchemeJException e) {
      return k.resume(e);
    }
  }

  /**
   * Returns true if the given number is the same as the arity of the
   * procedure that the closure represents.
   */
  public boolean checkArity(int num) {
    if ((num >= 1) && (num <= 3)) {
      return true;
    }
    else {
      return false;
    }
  }
}

