/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * GetField.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej.stdlib;

import kudos.schemej.util.*;
import kudos.lang.*;
import kudos.exns.*;
import kudos.jvm.*;
import java.lang.reflect.*;

/**
 * Implements the standard library procedure 'get-field'.
 *
 * @author Cheoljoo Jeong
 */

public class GetField extends Procedure {
  /**
   * The "apply"
   * Visitor is not used.
   */
  public Object apply(ExprVisitorI visitor, Object[] arguments, 
		      Environment r, Continuation k) 
    throws InvalidTypeException, SchemeJException 
  {
    KudosClassLoader classLoader = KudosClassLoader.getInstance();
    Object theObject = arguments[0];
    Field theField = null;
    String fieldname = "";

    try {
      if (arguments[1] instanceof String) {
	fieldname = (String) arguments[1];
      }
      else if (arguments[1] instanceof SSymbol) {
	fieldname = ((SSymbol) arguments[1]).getName();
      }
      else {
	throw new SchemeJException(SchemeJException.EvalError,
				   "(get-field <obj> \"fieldname\") or " +
				   "(get-field <obj> 'fieldname)");
      }
      System.out.println("getting field: " + fieldname);
      theField = theObject.getClass().getField(fieldname);
      System.out.println("get-field done");
      return k.resume(theField);

    } catch (SecurityException e) {
      throw new SchemeJException(SchemeJException.EvalError,
				 "cannot access field");
    } catch (NoSuchFieldException e) {
      throw new SchemeJException(SchemeJException.EvalError,
				 "no such field: " + fieldname);
    }
    
  }

  /**
   * Returns true if the given number is the same as the arity of the
   * procedure that the closure represents.
   */
  public boolean checkArity(int num) {
    if (num == 2) {
      return true;
    }
    else {
      return false;
    }
  }
}
