/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * ImplementsP.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej.stdlib;

import kudos.schemej.util.*;
import kudos.lang.*;
import kudos.exns.*;
import java.lang.reflect.*;

/**
 * Implements the standard library procedure 'implements?'.
 *
 * @author Cheoljoo Jeong
 */

public class ImplementsP extends Procedure {
  /**
   * The "apply."
   */
  public Object apply(ExprVisitorI visitor, Object[] arguments, 
		      Environment r, Continuation k) 
    throws SchemeJException
  {
    if (arguments[1] instanceof Class) {
      if (((Class) arguments[1]).isInterface()) {
	Class[] interfaces;

	if (arguments[0] instanceof Class) {
	  interfaces = ((Class) arguments[0]).getInterfaces();
	}
	else {
	  interfaces = arguments[0].getClass().getInterfaces();
	}

	for (int i = 0; i < interfaces.length; i++) {
	  String interfaceName = "interface " + interfaces[i].getName();
	  if (arguments[i] instanceof Class) {
	    if (interfaceName.equals(((Class) arguments[0]).getName())) {
	      return k.resume(new Boolean(true));
	    }
	  }
	  else {
	    if (interfaceName.equals(arguments[0].getClass().getName())) {
	      return k.resume(new Boolean(true));
	    }
	  }
	}

	return k.resume(new Boolean(false));
      }
      else {
	throw new SchemeJException(SchemeJException.EvalError,
				   "(implements? class interface) " +
				   "or (implements? obj interface)");
      }
    }
    else {
      throw new SchemeJException(SchemeJException.EvalError,
				 "(implements? class interface) " +
				 "or (implements? obj interface)");
    }
  }

  /**
   * Returns true if the given number is the same as the arity of the
   * procedure that the closure represents.
   */
  public boolean checkArity(int num) {
    if (num == 2) {
      return true;
    }
    else {
      return false;
    }
  }
}

