/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * LoadClass.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej.stdlib;

import kudos.schemej.util.*;
import kudos.lang.*;
import kudos.exns.*;
import kudos.jvm.*;

/**
 * Implements the standard library procedure 'load-class'.
 *
 * @author Cheoljoo Jeong
 */

public class LoadClass extends Procedure {
  /**
   * The "apply"
   * Visitor is not used.
   */
  public Object apply(ExprVisitorI visitor, Object[] arguments, 
		      Environment r, Continuation k) 
    throws InvalidTypeException, SchemeJException 
  {
    String classname = "";
    if (arguments[0] instanceof String) {
      classname = (String) arguments[0];
    }
    else if (arguments[0] instanceof SSymbol) {
      classname = ((SSymbol) arguments[0]).getName();
    }
    else {
      throw new InvalidTypeException("(load-class \"class-name\") or " +
				     "(load-class 'class-name)");
    }

    try {
      KudosClassLoader classLoader = KudosClassLoader.getInstance();
      Class theClass = classLoader.getClass(classname);

      return k.resume(theClass);
    } catch (ClassNotFoundException e) {
      throw new SchemeJException(SchemeJException.EvalError,
				 "class not found, " + classname);
    }
    
  }

  /**
   * Returns true if the given number is the same as the arity of the
   * procedure that the closure represents.
   */
  public boolean checkArity(int num) {
    if (num == 1) {
      return true;
    }
    else {
      return false;
    }
  }
}

