/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * MakeActionListener.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej.stdlib;

import kudos.schemej.*;
import kudos.schemej.util.*;
import kudos.lang.*;
import kudos.exns.*;
import javax.swing.*;
import java.awt.event.*;

/**
 * Implements the standard library procedure 'make-action-listener'.
 *
 * @author Cheoljoo Jeong
 */

public class MakeActionListener extends Procedure {
  /**
   * The "apply"
   */
  public Object apply(ExprVisitorI visitor, Object[] arguments, 
		      Environment r, Continuation k) 
    throws InvalidTypeException, SchemeJException
  {
    if (!(arguments[0] instanceof SExpr)) {
      throw new SchemeJException(SchemeJException.EvalError,
				 "(make-action-listener 'quoted-expr)");
    }

    final SExpr sexpr = (SExpr) arguments[0];
    final Environment env = r;
    final Continuation cont = k;

    // make an action listener;
    // action listener code is lazy-evaluated
    ActionListener listener = 
      new ActionListener() {
	  public void actionPerformed(ActionEvent e) {
	    try {
	      Evaluator eval = new Evaluator();
	      Expr expr = (Expr) sexpr.accept(new SExprParser());
	      Object value = expr.eval(eval, env, cont);
	    } catch (SchemeJException exn) {
	    }
	  }
	};

    return k.resume(listener);
  }

  /**
   * Returns true if the given number is the same as the arity of the
   * procedure that the closure represents.
   */
  public boolean checkArity(int num) {
    if (num == 1) {
      return true;
    }
    else {
      return false;
    }
  }
}

