/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * Read.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej.stdlib;

import kudos.schemej.*;
import kudos.schemej.util.*;
import kudos.lang.*;
import kudos.exns.*;
import java.io.*;

/**
 * Reads characters from the user input and returns 
 * a single s-expression.
 *
 *
 * @author Cheoljoo Jeong
 */

public class Read extends Procedure {
  /**
   * The "apply"
   */
  public Object apply(ExprVisitorI visitor, Object[] arguments, 
		      Environment r, Continuation k) 
    throws InvalidTypeException 
  {
    try {
      String list = readList();
      char[] clist = list.toCharArray();
      if (clist.length > 0) {
	CharArrayReader inp = new CharArrayReader(clist);
	
	Parser parser = new Parser(new Lexer(inp));
	java_cup.runtime.Symbol sym = parser.parse();
	SExpr sexpr = (SExpr) sym.value;
	
	return sexpr;
      }
      else {
	return null;
      }
    } catch (IOException e) {
      return null;
    } catch (Exception e) {
      return null;
    }
  }

  /**
   * Reads a list from the standard input and returns a list.
   * A list may span multiple lines.
   */
  private String readList() {
    StringBuffer buffer = new StringBuffer();
    boolean balanced = true;
    int leftpar = 0;
    int rightpar = 0;
    char c = 'c';

    for (;;) {
      try {
	c = (char) System.in.read();
      } catch (IOException e) {
	e.printStackTrace();
      }
      if (c != '\n') {
	if (c == '(') {
	  leftpar++;
	  balanced = false;
	}
	if (c == ')') {
	  rightpar++;
	  if (leftpar == rightpar) {
	    balanced = true;
	  }
	  else if (leftpar < rightpar) {
	    try {
	      System.in.skip(1);
	    } catch (IOException e) { 
	    }
	    break;
	  }
	}
	buffer.append(c);
      }
      else {
	if (balanced == false) {
	  System.out.println(" > ");
	}
	else {
	  break;
	}
      }
    }
    return buffer.toString();
  }

  /**
   * Returns true if the given number is the same as the arity of the
   * procedure that the closure represents.
   */
  public boolean checkArity(int num) {
    if (num == 0) {
      return true;
    }
    else {
      return false;
    }
  }
}

