/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * Atom.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej.util;

import kudos.exns.*;


/**
 * Implements the null list of Lisp/Scheme.
 *
 * @author Cheoljoo Jeong
 */
public class NullList extends SExpr {

  /**
   * constructor
   */
  public NullList() {
  }

  
  /**
   * Returns true iff this instance is atom;
   */
  public boolean isAtom() {
    return false;
  }

  /**
   * Returns true iff this instance is pair;
   */
  public boolean isPair() {
    return false;
  }

  /**
   * Returns true iff this instnace is null;
   */
  public boolean isNullList() {
    return true;
  }

  /**
   * Returns the length of this list.
   */
  public int length() {
    return 0;
  }

  /**
   * Acceptor method for visitor pattern.
   */
  public Object accept(SExprVisitorI visitor) throws SchemeJException {
    try {
      return visitor.visitNullList(this);
    } catch (SchemeJException e) {
      throw e;
    }
  }

}




