/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * SExpr.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej.util;

import kudos.exns.*;

/**
 * Represents the s-expressions of Lisp/Scheme.
 * An s-expression is either an atom or a pair.
 *
 * @author Cheoljoo Jeong
 */
public abstract class SExpr {
  /**
   * constructor
   */
  public SExpr() {
  }

  /**
   * Returns true iff this instance is atom;
   * should be overrided by the subclass.
   */
  public abstract boolean isAtom();
  
  /**
   * Returns true iff this instance is pair;
   * should be overrided by the subclass.
   */
  public abstract boolean isPair();

  /**
   * Returns true iff this instnace is null;
   */
  public abstract boolean isNullList();

  /**
   * Returns the length.
   */
  public abstract int length();

  /**
   * Acceptor method for visitor pattern.
   */
  public abstract Object accept(SExprVisitorI visitor) 
    throws SchemeJException;

}
