/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * SNumber.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej.util;

/**
 * Implements the numbers of Lisp/Scheme.
 * For a full r5rs-compliant implementation, we need to 
 * implement this fully.
 *
 * @author Cheoljoo Jeong
 */

public class SNumber extends Atom {

  /**
   * constructor
   */
  public SNumber(Double number) {
    super(Token.Number, (Object) number);
  }

  /**
   * constructor
   */
  public SNumber(int id, Double number)
  {
    super(id, number);
  }
  
  /**
   * compares this symbol with another symbol for equality;
   */
  public boolean equals(SNumber snum) {
    if (this == snum) {
      return true;
    }
    if (snum == null) {
      return false;
    }
    
    if (this.value == snum.value) {
      return true;
    }
    else {
      return false;
    }
  }

  /**
   * static method for comparing two pairs for equality
   */
  static public boolean equals(SNumber snum1, SNumber snum2) {
    if (snum1 != null) {
      return snum1.equals(snum2);
    }
    else if (snum2 == null) {
      return true;
    }
    else {
      return false;
    }
  }
}


