/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * SSymbol.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej.util;

/**
 * implements the symbols of List/Scheme
 *
 * @author Cheoljoo Jeong
 */
public class SSymbol extends Atom {
  /**
   * constructor
   */
  public SSymbol(String name) {
    super(Token.Symbol, name);
  }

  /**
   * constructor
   */
  public SSymbol(int id, String name)
  {
    super(id, name);
  }
  
  /**
   * compares this symbol with another symbol for equality;
   */
  public boolean equals(SSymbol symbol) {
    if (this == symbol) {
      return true;
    }
    if (symbol == null) {
      return false;
    }
    
    if (this.value.equals(symbol.value)) {
      return true;
    }
    else {
      return false;
    }
  }

  /**
   * static method for comparing two pairs for equality
   */
  static public boolean equals(SSymbol symbol1, SSymbol symbol2) {
    if (symbol1 != null) {
      return symbol1.getName().equals(symbol2.getName());
    }
    else if (symbol2 == null) {
      return true;
    }
    else {
      return false;
    }
  }

  public int getId() {
    return id;
  }

  public String getName() {
    return (String) value;
  }
}




