/* -*---------------------------------------------------------
 * Uses: Classic VM (build JDK-1.2-V, green threads, sunwjit)
 * -*---------------------------------------------------------
 * @(#) $Id$
 *
 * Token.java: 
 *   - created by Cheoljoo Jeong
 *
 * Copyleft(c) 2000. Cheoljoo Jeong. All lefts reserved.
 *
 * $Log$
 */

package kudos.schemej.util;

/**
 * Defines the token id's to be used with the lexer and the parser.
 *
 * @author Cheoljoo Jeong
 */
public class Token {
  // for keywords
  public static final int Define  = 0x0000;
  public static final int Lambda  = 0x0001;
  public static final int Begin   = 0x0002;
  public static final int Let     = 0x0003;
  public static final int Letrec  = 0x0004;
  public static final int Letstar = 0x0005;
  public static final int Set     = 0x0006;
  public static final int If      = 0x0007;
  public static final int Cond    = 0x0008;
  public static final int Else    = 0x0009;

  // for symbols
  public static final int Symbol  = 0x0010;

  // for literals
  public static final int Number  = 0x0100;
  public static final int String  = 0x0101;
  public static final int False   = 0x0102;
  public static final int True    = 0x0103;

  // for parentheses
  public static final int Lparen  = 0x1000;
  public static final int Rparen  = 0x1001;

  // misc
  public static final int Eof     = 0x1111;
  public static final int Newline = 0x1112;


}






