(define (and x y) (if x y #f))
(define (or x y) (if x #t y))
(define (not x) (if x #f #t))

(define lat? 
  (lambda (l) 
    (if (null? l)
	#t
	(if (symbol? (car l))
	    (lat? (cdr l))
	    #f))))
		
(define member?
  (lambda (a lat)
    (if (null? lat) 
	#f
	(or (eqv? (car lat) a)
	    (member? a (cdr lat))))))

(define rember
  (lambda (a lat)
    (if (null? lat) 
	'()
	(if (eqv? (car lat) a)
	    (rember a (cdr lat))
	    (cons (car lat) (rember a (cdr lat)))))))

(letrec ((f (lambda (x) (if (= x 1) 1 (* x (f (- x 1))))))) (f 4))


;; for demo
(define control-c (load-class "Control"))
(define control-o (create-object control-c))
(define diet-c (load-class "Diet"))
(define diet-o (create-object diet-c "180" "75"))

(define dimension-c (load-class "java.awt.Dimension"))
(define (new-dim x y)
  (create-object dimension-c x y))
(define (set-xy obj x y)
  (send obj 'setLocation x y))

(send control-o 'setSize (new-dim 300 350))
(send diet-o 'setSize (new-dim 300 350))
(set-xy control-o 8 8)
(set-xy diet-o 328 8)
(send control-o 'setVisible #t)
(send diet-o 'setVisible #t)

(define cl1 (get-field-value control-o 'label1))
(define cl2 (get-field-value control-o 'label2))
(define cl3 (get-field-value control-o 'label3))
(define cl4 (get-field-value control-o 'label4))
(define ctf1 (get-field-value control-o 'tf1))
(define ctf2 (get-field-value control-o 'tf2))
(define ctf3 (get-field-value control-o 'tf3))
(define ctf4 (get-field-value control-o 'tf4))
(define button1 (get-field-value control-o 'submit))

(define dsl1 (get-field-value diet-o 'height))
(define dsl2 (get-field-value diet-o 'weight))
(define dl1 (get-field-value diet-o 'label1))
(define dl2 (get-field-value diet-o 'label2))
(define dl3 (get-field-value diet-o 'label3))
(define dl4 (get-field-value diet-o 'label4))
(define button2 (get-field-value diet-o 'kaufButton))

(define str->int
  (lambda (str) 
    (send-static (load-class "java.lang.Integer") 'parseInt str)))

(define al1 
  (make-action-listener
   '(let ((height (send ctf1 'getText))
	  (weight (send ctf2 'getText)))
      (begin
	(send dsl1 'setValue (str->int height))
	(send dsl2 'setValue (str->int weight))))))

(define al2 
  (make-action-listener
   '(let* ((height (send dsl1 'getValue))
	   (weight (send dsl2 'getValue))
	   (kauf (- height 110)))
      (send dl4 'setText
	    (if (> kauf weight) "Good" "Bad")))))

(send button1 'addActionListener al1)
(send button2 'addActionListener al2)

(define hide (lambda (x) (send x 'setVisible #f)))
(define show (lambda (x) (send x 'setVisible #t)))












